<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////
							
						admin_validate_section("statistics",1);
						$action = $GLOBALS["Get"]->val("action");
						
						include_once(DOC_ROOT."/classes/Videos.class.php");
								
							switch($action){
										
								case '':
									stats_overview();
									break;
									
								case 'videos':
									stats_videos();
									break;
									
								case 'members':
									stats_members();
									break;
									
							}//switch
							
						///////////////////////////////////////
						
function stats_overview(){
	
	admin_validate();
	
	include_once(DOC_ROOT."/classes/Groups.class.php");
	
	$data["section"] = "statistics";
	$data["subsection"] = 1;
	$data["title_id"] = 52;
	
	$stats = array();
	
	//top videos by views
	$sql_query = "SELECT vid_id, viewed FROM videos ORDER BY viewed DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["videos_by_views"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$card["order"] = $res["viewed"];
		$stats["videos_by_views"][] = $card;
	}
	
	//top vidos by favorites
	$sql_query = "SELECT v.vid_id, COUNT(*) AS ord FROM videos AS v JOIN bookmarks AS b
				  ON v.vid_id = b.item_id
				  GROUP BY v.vid_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["videos_by_favorites"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$card["order"] = $res["ord"];
		$stats["videos_by_favorites"][] = $card;
	}
	
	//top members by video uploads
	$sql_query = "SELECT COUNT(*) AS ord, mem_id FROM videos GROUP BY mem_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["members_by_uploads"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["order"] = $res["ord"];
		$stats["members_by_uploads"][] = $card;
	}
	
	//top members by video views
	$sql_query = "SELECT mem_id, SUM(viewed) AS ord FROM videos GROUP BY mem_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["members_by_video_views"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["order"] = $res["ord"];
		$stats["members_by_video_views"][] = $card;
	}
	
	//top members by channel views
	$sql_query = "SELECT mem_id, views AS ord FROM channels ORDER BY views DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["members_by_channel_views"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["order"] = $res["ord"];
		$stats["members_by_channel_views"][] = $card;
	}
	
	//top members by subscriptions
	$sql_query = "SELECT c.mem_id, COUNT(*) AS ord FROM channels AS c LEFT JOIN subscriptions AS s
				  ON (c.mem_id = s.sub_id AND s.type = 'channel')
				  GROUP BY c.mem_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["members_by_subscriptions"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["order"] = $res["ord"];
		$stats["members_by_subscriptions"][] = $card;
	}
	
	//top groups by videos
	$sql_query = "SELECT g.grp_id, COUNT(*) AS ord FROM groups AS g LEFT JOIN group_videos AS gv
				  ON (g.grp_id = gv.grp_id) WHERE gv.approved='1'
				  GROUP BY g.grp_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["groups_by_videos"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Groups"]->card( $res["grp_id"] );
		$card["order"] = $res["ord"];
		$stats["groups_by_videos"][] = $card;
	}
	
	//top groups by members
	$sql_query = "SELECT g.grp_id, COUNT(*) AS ord FROM groups AS g LEFT JOIN group_members AS gm
				  ON (g.grp_id = gm.grp_id)
				  GROUP BY g.grp_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["groups_by_members"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Groups"]->card( $res["grp_id"] );
		$card["order"] = $res["ord"];
		$stats["groups_by_members"][] = $card;
	}
	
	$data["stats"] = $stats;
	
	$layout[0] = "statistics_overview";
	
	admin_output($layout,$data);
	
}

function stats_videos() {
	
	admin_validate();
	
	$data["section"] = "statistics";
	$data["subsection"] = 2;
	$data["title_id"] = 52;
	
	$stats = array();
	
	//duration
	//average
	$sql_query = "SELECT SUM(length) FROM videos WHERE converted = '1'";
	$sum = $GLOBALS["DB"]->single( $sql_query );
	$sql_query = "SELECT COUNT(*) FROM videos WHERE converted = '1'";
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	//less than 1 minute
	$sql_query = "SELECT COUNT(*) FROM videos WHERE length <= 60 AND approved='1'";
	$stats["duration"]["less1"] = $GLOBALS["DB"]->single( $sql_query );
	$stats["duration"]["less1_percent"] = @round( ($stats["duration"]["less1"] / $total) * 100 );
	if( !$stats["duration"]["less1_percent"] )
		$stats["duration"]["less1_percent"] = 0;
	
	//1-5 minutes
	$sql_query = "SELECT COUNT(*) FROM videos WHERE (length > 60 AND length <= 300) AND approved='1'";
	$stats["duration"]["1-5"] = $GLOBALS["DB"]->single( $sql_query );
	$stats["duration"]["1-5_percent"] = @round( ($stats["duration"]["1-5"] / $total) * 100 );
	if( !$stats["duration"]["1-5_percent"] )
		$stats["duration"]["1-5_percent"] = 0;
	
	//5-10 minutes
	$sql_query = "SELECT COUNT(*) FROM videos WHERE (length > 300 AND length <= 600) AND approved='1'";
	$stats["duration"]["5-10"] = $GLOBALS["DB"]->single( $sql_query );
	$stats["duration"]["5-10_percent"] = @round( ($stats["duration"]["5-10"] / $total) * 100 );
	if( !$stats["duration"]["5-10_percent"] )
		$stats["duration"]["5-10_percent"] = 0;
	
	//more than 10 minutes
	$sql_query = "SELECT COUNT(*) FROM videos WHERE length > 600 AND approved='1'";
	$stats["duration"]["more10"] = $GLOBALS["DB"]->single( $sql_query );
	$stats["duration"]["more10_percent"] = @round( ($stats["duration"]["more10"] / $total) * 100 );
	if( !$stats["duration"]["more10_percent"] )
		$stats["duration"]["more10_percent"] = 0;
		
	//countries
	$sql_query = "SELECT COUNT(*) AS ord, p.country FROM profiles AS p, videos AS v
				  WHERE p.mem_id = v.mem_id AND v.converted = '1' GROUP BY p.country ORDER BY ord DESC";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["countries"] = array();
	foreach($result as $res) {
		$card = array();
		$card["country"] = extract_country( $res["country"] );
		$card["amount"]  = $res["ord"];
		$card["percent"] = round( ($res["ord"] / $total) * 100 );
		$stats["countries"][] = $card;
	}
	
	$data["stats"] = $stats;
	
	$layout[0] = "statistics_videos";
	
	admin_output($layout,$data);
	
}

function stats_members() {
	
	admin_validate();
	
	$data["section"] = "statistics";
	$data["subsection"] = 3;
	$data["title_id"] = 52;
	
	$stats = array();
	
	$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM members WHERE verified='1'" );
	
	//country
	$sql_query = "SELECT COUNT(*) AS ord, country FROM profiles AS p, members AS m
				  WHERE p.mem_id = m.mem_id AND m.verified='1' GROUP BY country ORDER BY ord DESC";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["countries"] = array();
	foreach($result as $res) {
		$card = array();
		$country = extract_country( $res["country"] );
		$card["country"] = ($country) ? $country : "Unknown";
		$card["amount"]  = $res["ord"];
		$card["percent"] = @round( ($res["ord"] / $total) * 100 );
		$stats["countries"][] = $card;
	}
	
	//most uploads
	$sql_query = "SELECT COUNT(*) AS ord, mem_id FROM videos GROUP BY mem_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["members_by_uploads"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["order"] = $res["ord"];
		$stats["uploads"][] = $card;
	}
	
	//most active
	$sql_query = "	SELECT SUM( cnt ) AS ord, mem_id
					FROM (
					
					SELECT COUNT( * ) AS cnt, mem_id
					FROM video_comments
					GROUP BY mem_id
					UNION ALL
					SELECT COUNT( * ) AS cnt, `from` AS mem_id
					FROM channel_comments
					GROUP BY mem_id
					) AS kk
					GROUP BY mem_id
					ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["active"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["order"] = $res["ord"];
		$stats["active"][] = $card;
	}
	
	//most invites
	$sql_query = "SELECT COUNT(*) AS ord, mem_id FROM invitations GROUP BY mem_id ORDER BY ord DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$stats["invites"] = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["order"] = $res["ord"];
		$stats["invites"][] = $card;
	}
	
	$data["stats"] = $stats;
	
	$layout[0] = "statistics_members";
	
	admin_output($layout,$data);
	
}
						
?>