<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

class Videos extends DB{

	function Videos(){

		$this->values = array();
		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/videos.inc.php");

		foreach($videos as $key => $val) {
			$this->$key = $val;
		}

	}//Videos
	
	function info( $vid_id ){
		static $cache = array();
		
		if(isset($cache[$vid_id]))
			return $cache[$vid_id];
			
		$sql_query = "SELECT * FROM videos WHERE vid_id=".$vid_id;
		$info = $this->row( $sql_query );
		
		$cache[$vid_id] = $info;
		
		return $info;
	}

	function categories(){

		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/video_categories.inc.php");
		return $categories;

	}//categoies

	function category($set){

		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/video_categories.inc.php");

		$category = "";
		$cats = handle_empties(explode("|",$set));
		foreach($cats as $cat){
			$category.= $categories[$cat].", ";
		}//if
		$category = rtrim($category,", ");

		return $category;

	}//category

	function card($vid_id){
		
		$card = array();
		
		$info = $GLOBALS["Member"]->info();

		$video = $this->info( $vid_id );
		
		if(!$video["vid_id"])
			return array();

		$card["vid_id"]           = $vid_id;
		$card["mem_id"]           = $video["mem_id"];		
		$card["from"]             = $GLOBALS["Member"]->card($video["mem_id"]);
		$card["title"]            = $video["title"];
		$card["title_cut"]        = handle_string_cut( $video["title"], 15 );
		$card["title_cut_30"]     = handle_string_cut( $video["title"], 30 );
		$card["description"]      = nl2br( hs_wordwrap( handle_string_cut( $video["description"] ), 30 ) );
		$card["description_line"] = handle_string_cut( $video["description"], 50 );
		$card["link"]             = "index.php?page=videos&section=view&vid_id=".$vid_id;
		$card["shash"]            = $this->screenshot( $vid_id );
		$card["vid_id"]           = $vid_id;
		$card["category"]         = $video["category"];
		$card["category_name"]    = $this->category($video["category"]);
		$card["duration"]         = extract_duration( $video["length"] );
		$card["posted_orig"]      = $video["posted"];
		$card["posted"]           = extract_date( $video["posted"] );
		$card["posted_relative"]  = extract_time_relative( $video["posted"] );
		$card["tags"]             = extract_tags( $video["tags"] );
		$card["views"]            = $video["viewed"];		
		$card["view"]             = $card["link"];		
		$card["channel"]          = $this->is_channel_video( $vid_id );
		$card["rating"]           = $this->rating_format( $video["rating"], $video["votes"] );

		if($video["featured"])
			$card["featured"] = 1;
		else
			$card["featured"] = 0;

		if($video["mem_id"] == $info["mem_id"]){
			$card["edit"] = "index.php?page=videos&section=edit&vid_id=".$vid_id;
			$card["delete"] = "index.php?handler=videos&action=delete&vid_id=".$vid_id;
		}//if
		
		$card["comments"] = $this->comments( $vid_id );

		return $card;

	}//card
	
	function screenshot( $vid_id ) {
		$video = $this->info( $vid_id );		
		if($video["source"] == "embed") {
			include_once( DOC_ROOT."/modules/grabber/".$video["service"].".php" );			
			return g_screenshot_path( $video["vhash"] )."/".$video["screenshot"].".jpg";
		}
		else
			return ( $video["shash"] ) ? $video["shash"]."_".$video["screenshot"] : "";
	}
	
	function is_channel_video( $vid_id ){
		
		static $videos;
		if(!is_array($videos)) {
			$info = $GLOBALS["Member"]->info();
			$sql_query = "SELECT videos FROM channels WHERE mem_id=".$info["mem_id"];
			$videos = explode(",", $GLOBALS["DB"]->single( $sql_query ));
		}
		return in_array($vid_id, $videos);
		
	}
	
	function is_channel_fav( $vid_id ){
		
		static $videos;
		if(!is_array($videos)) {
			$info = $GLOBALS["Member"]->info();
			$sql_query = "SELECT favorites FROM channels WHERE mem_id=".$info["mem_id"];
			$videos = explode(",", $GLOBALS["DB"]->single( $sql_query ));
		}
		return in_array($vid_id, $videos);
		
	}
	
	function response_to ( $vid_id ) {
		$sql_query = "SELECT response_to FROM video_responses WHERE vid_id=".$vid_id." AND approved='1'";
		$result = $this->result( $sql_query );
		$responses = "";
		foreach($result as $res) {
			$card = $this->card( $res["response_to"] );
			$responses.= "<a href='".$card["link"]."'>".$card["title"]."</a>, ";
		}
		return trim($responses, ", ");
	}
	
	function is_bookmarked( $vid_id, $mem_id = 0 ) {
		if(!$mem_id){
			$info = $GLOBALS["Member"]->info();
			$mem_id = $info["mem_id"];
		}
		$sql_query = "SELECT COUNT(*) FROM bookmarks WHERE mem_id=".$info["mem_id"]." AND item_id=".$vid_id;
		return $this->single( $sql_query );
	}
	
	function comments( $vid_id ) {
		$sql_query = "SELECT COUNT(*) FROM video_comments WHERE vid_id=".$vid_id." AND reply_to=0 AND approved='1'";
		return $this->single( $sql_query );
	}
	
	function responses( $vid_id ) {
		$sql_query = "SELECT COUNT(*) FROM video_responses AS vr,videos AS v WHERE vr.vid_id=v.vid_id AND vr.approved='1' AND vr.response_to=".$vid_id." ".$this->filter("v.");
		return $this->single( $sql_query );
	}
	
	function bookmarks( $vid_id ) {
		$sql_query = "SELECT COUNT(*) FROM bookmarks WHERE item_id=".$vid_id;
		return $this->single( $sql_query );
	}
	
	function rating( $vid_id ) {
		$info = $this->info( $vid_id );
		$rating = $this->rating_format( $info["rating"], $info["votes"] );
		return $rating;
	}
	
	function rating_format( $rate, $votes ) {
		$value = @round($rate / $votes, 1);
		$rating = array();
		$rating["rounded"] = @round($value);
		$rating["int"] = (int)($value);
		$rating["residue"] = ($value - $rating["int"]) * 10;
		$rating["votes"] = $votes;
		return $rating;
	}

	function voting($vid_id,$mem_id){

		$sql_query = "SELECT * FROM videos WHERE vid_id=".$vid_id;
		$video = $this->row($sql_query);

		if(!$video["voting"])
			return false;

		$sql_query = "SELECT videos FROM video_votes WHERE mem_id=".$mem_id;
		$videos = handle_empties(explode(",",$this->single($sql_query)));

		if(in_array($vid_id,$videos))
			return false;

		return true;

	}//voting
	
	function add_to_playlist( $vid_id, $pla_id ) {
		$sql_query = "SELECT COUNT(*) FROM playlist_videos WHERE vid_id=:0: AND pla_id=:1:";
		$this->values = array($vid_id, $pla_id);
		$exists = $this->single( $sql_query );
		if(!$exists) {
			$sql_query = "SELECT MAX(position) FROM playlist_videos WHERE pla_id=".$pla_id;
			$position  = $this->single( $sql_query );
			$position++;
			if($position == 1)
				$main = 1;
			else
				$main = 0;
				
			$sql_query = "INSERT INTO playlist_videos (vid_id, pla_id, position, main, added) VALUES (:0:,:1:,:2:,':3:',:4:)";
			$this->values = array( $vid_id, $pla_id, $position, $main, time() );
			$this->execute( $sql_query );
		}
		return true;
	}
	
	function rated( $mem_id, $vid_id ) {
		$sql_query = "SELECT COUNT(*) FROM video_votes WHERE mem_id=:0: AND vid_id=:1: AND timestamp >= :2:";
		$this->values = array( $mem_id, $vid_id, (time() - 3600*24) );
		return $this->single( $sql_query );
	}
	
	function filter( $table = "" ) {
		$info = $GLOBALS["Member"]->info();
		$filter = " AND ".$table."converted='1' AND ".$table."broadcast = 0 ";
		if(!$this->show_unapproved) { $filter.= " AND ".$table."approved='1' "; }
		return $filter;
	}
	
	function show( $vid_id, $pla_id, $ext ) {
		
		$err_id = 0;
		$error  = "none";		
		
		if($pla_id && !$vid_id) {
			$sql_query = "SELECT pv.vid_id FROM playlist_videos AS pv, videos AS v WHERE pv.vid_id=v.vid_id AND pv.pla_id=".$pla_id." ".$GLOBALS["Videos"]->filter("v.")."
						  ORDER BY pv.position ASC LIMIT 0,1";
			$vid_id = $this->single( $sql_query );
		}
		
		if($pla_id) {
			$sql_query = "SELECT * FROM playlists WHERE pla_id=".$pla_id;
			$playlist = $this->row( $sql_query );
		}
		
		$entry = $this->info( $vid_id );
		
		if(!$entry["vid_id"])
			$err_id = 53;
		
		if(!auth_video_access_ajax( $vid_id ))
			$err_id = 54;
			
		if( $ext && ( ($pla_id && $playlist["embedding"] == 2) || ($vid_id && $entry["embedding"] == 2) ) )
			$err_id = 55;
			
		if($err_id) {
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/errors.inc.php");
			$error = $errors[$err_id];
		}
	
		
		if(!$entry["server"])
			$file = URL."/vid/".$entry["vhash"].".flv";
		else {
			include(DOC_ROOT."/includes/config/servers.inc.php");
			$file = $servers[$entry["server"]]["url"]."/vid/".$entry["vhash"].".flv";
		}
		
		$next = "none";
		
		if($pla_id) {
			$sql_query = "SELECT pv.vid_id FROM playlist_videos AS pv, videos AS v WHERE pv.vid_id=v.vid_id AND pv.pla_id=".$pla_id." ".$this->filter("v.")."
						  ORDER BY pv.position ASC";
			$result = $this->result( $sql_query );
			$first = $result[0]["vid_id"];
			foreach($result as $key => $res) {
				if($res["vid_id"] == $vid_id) {
					if( $result[$key+1]["vid_id"] )
						$next = $result[$key+1]["vid_id"];
					else
						$next = $first;
					break;
				}
			}
		}
		
		$seconds = auth_getpaid_video_watch_access();
		
		if( file_exists( DOC_ROOT."/scr/".$entry["shash"]."_".$entry["screenshot"]."_b.jpg" ) )
			$screenshot = $entry["shash"]."_".$entry["screenshot"]."_b";
		else
			$screenshot = "none";
			
		if( function_exists( "extract_available_video_ads" ) ) {
			
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/ads.inc.php");
			
			$banners = extract_available_video_ads();
			
			$ads_xml = '<ads mid_start="'.$ads["settings"]["mid_start"].'" mid_end="'.$ads["settings"]["mid_end"].'" mid_rotation="'.$ads["settings"]["mid_rotation"].'" mid_jpeg_width="'.$ads["settings"]["mid_jpeg_width"].'" mid_jpeg_height="'.$ads["settings"]["mid_jpeg_height"].'" mid_swf_width="'.$ads["settings"]["mid_swf_width"].'" mid_swf_height="'.$ads["settings"]["mid_swf_height"].'">';
			
			//pre
			if(!$banners["pre"])
				$ads_xml.= "<pre>none</pre>";
			else
				$ads_xml.= "<pre>".extract_video_ad_xml( $banners["pre"] )."</pre>";
				
			//post
			if(!$banners["post"])
				$ads_xml.= "<post>none</post>";
			else
				$ads_xml.= "<post>".extract_video_ad_xml( $banners["post"] )."</post>";
				
			//mid
			if(!$banners["mid"])
				$ads_xml.= "<mid>none</mid>";
			else {
				$ads_xml.= "<mid>";
				foreach($banners["mid"] as $ad) {
					$ads_xml.= "<ad>".extract_video_ad_xml( $ad )."</ad>";
				}
				$ads_xml.= "</mid>";		
			}
			
			$ads_xml.= '</ads>';
			
		}
		
		return "<reply><error>".htmlspecialchars( $error )."</error><vid_id>".$vid_id."</vid_id><flv>".$file."</flv><logo>".$this->logo."</logo><next>".htmlspecialchars( $next )."</next><limit>".htmlspecialchars( $seconds )."</limit><length>".htmlspecialchars( $entry["length"] )."</length><screenshot>".htmlspecialchars( $screenshot )."</screenshot>".$ads_xml."</reply>";
		
	}

}//Videos class

$GLOBALS["Videos"] = new Videos;