<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function build_page($p_details=0,$popup=0,$structure=0){

	global $page_details,$forms,$menus,$info;

	build_language();

	$GLOBALS["smarty"]->assign("language",$GLOBALS["language"]);

	$info = $GLOBALS["Member"]->info();
	$page_details = $GLOBALS["Get"]->page_details($p_details);
	$page_details["popup"] = $popup;

	$mainurl = extract_mainurl_relative();

	if(!empty($page_details["handler"])){
		if(file_exists(DOC_ROOT."/modules/".$page_details["handler"].".php"))
			include_once(DOC_ROOT."/modules/".$page_details["handler"].".php");
		else
			load_page(URL."/index.php?err_id=19");
	}//if

	if(!file_exists(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/templates/source/pages/".$page_details["items_file"].".tpl"))
		load_page(URL."/index.php?err_id=19");

	$page_auth = extract_page_auth($page_details["items_file"]);

	foreach($page_auth as $auth_func){
		$auth_func();
	}//foreach

	$title = build_title($page_details["items_file"]);

	$page_forms = extract_page_forms($page_details["items_file"]);

	foreach($page_forms as $page_form){
		build_form($page_form);
	}//foreach

	$page_modules = extract_page_modules($page_details["items_file"]);

	foreach($page_modules as $page_module){
		$module_info = explode("|",$page_module);
		$module_name = $module_info[0];
		$func = $module_info[1];
		if(!function_exists($func))
			include_once(DOC_ROOT."/modules/".$module_name.".php");
		$func();
	}//foreach

	$page_menus = extract_page_menus($page_details["items_file"]);

	foreach($page_menus as $page_menu){
		build_menu($page_menu);
	}//foreach

	build_javascript();
	build_meta();
	build_tip($page_details["items_file"]);

	if(count($forms) > 0){

	while(list($k,$v) = each($forms)){
		$sort_array[$k] = array_search($k,$page_forms);
		$form_array[$k] = $v;
	}//while

	array_multisort($sort_array,$form_array);
	$forms = $form_array;

	}//if
	
	build_rss_links();

	$encoding = extract_encoding("html");

	$banners = extract_available_banners();

	include( DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/social_bookmarking.inc.php" );
	if($social_bookmarking["enabled"]) {
		include_once( DOC_ROOT."/modules/social_bookmarking.php" );
		if(bookmarking_links( $title ))
			$GLOBALS["smarty"]->assign("sbmodule","enabled");
	}//if

	include_once( DOC_ROOT."/modules/tags.php" );
	if(generate_tags()) {
		$GLOBALS["smarty"]->assign("tagsmodule", "enabled");
	}
	
	include( DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/videos.inc.php" );

	$GLOBALS["smarty"]->assign("root_url", URL);
	$GLOBALS["smarty"]->assign("url", $mainurl);
	$GLOBALS["smarty"]->assign("page",$page_details["page"]);
	$GLOBALS["smarty"]->assign("section",$page_details["section"]);
	$GLOBALS["smarty"]->assign("meta",$page_details["meta"]);
	$GLOBALS["smarty"]->assign("forms",$forms);
	$GLOBALS["smarty"]->assign("info",$info);
	$GLOBALS["smarty"]->assign("menus",$menus);
	$GLOBALS["smarty"]->assign("encoding",$encoding);
	$GLOBALS["smarty"]->assign("banners",$banners);
	$GLOBALS["smarty"]->register_function("banner","build_banner");

	if(is_numeric($page_details["err_id"])){
		build_error($page_details["err_id"],-1);
	}//if

	if(is_numeric($page_details["cmp_id"])){
		build_complete($page_details["cmp_id"]);
	}//if

	if(substr_count($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')){
		ob_start('ob_gzhandler');
		Header("Content-Encoding: gzip");
	}//if
	else
		ob_start();

	Header("Content-Type: text/html; charset=".$encoding);
	Header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    Header("Cache-Control: no-cache, must-revalidate");
	Header("Pragma: no-cache");

	build_output($page_details["items_file"], $popup);
	exit;

}//build_page

function build_ajax($p_details=0){

	global $page_details,$forms,$menus;

	build_language();

	$GLOBALS["smarty"]->assign("language",$GLOBALS["language"]);

	$module = $GLOBALS["Get"]->ajax_module();

	if(file_exists(DOC_ROOT."/ajax/".$module.".php"))
		include_once(DOC_ROOT."/ajax/".$module.".php");
	else
		exit;

	exit;

}//build_ajax

function build_rss_links() {
	
	$links = array();	
	$link  = array();
	
	$link["title"] = $GLOBALS["settings"]["site_name"]." - ".$GLOBALS["language"]["recently_added"];
	$link["href"] = URL."/modules/rss.php?type=recent";	
	$links[] = $link;
	
	$link["title"] = $GLOBALS["settings"]["site_name"]." - ".$GLOBALS["language"]["most_viewed"];
	$link["href"] = URL."/modules/rss.php?type=viewed";	
	$links[] = $link;
	
	$link["title"] = $GLOBALS["settings"]["site_name"]." - ".$GLOBALS["language"]["most_discussed"];
	$link["href"] = URL."/modules/rss.php?type=discussed";	
	$links[] = $link;
	
	$link["title"] = $GLOBALS["settings"]["site_name"]." - ".$GLOBALS["language"]["top_favorites"];
	$link["href"] = URL."/modules/rss.php?type=favorites";	
	$links[] = $link;
	
	$GLOBALS["smarty"]->assign("rss", $links);
	
}

function build_language(){

	$language = array();
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/language.inc.php");
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/language_cached.inc.php");
	$GLOBALS["language"] = $language;

}//build_language

function build_title($page_code){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/titles.inc.php");
	$title = ereg_replace("\|site_name\|",$GLOBALS["settings"]["site_name"],$titles[$page_code]);
	
	$username = $GLOBALS["Get"]->val("u");
	if(!$username)
		$username = $GLOBALS["Member"]->username();	
	
	$title = ereg_replace("\|username\|",$username,$title);
	$GLOBALS["smarty"]->assign("page_title",$title);
	return $title;

}//build_title

function build_meta(){

	global $page_details;

	if(!$page_details["meta"]){
		$page_details["meta"]["description"] = $GLOBALS["settings"]["description"];
		$page_details["meta"]["keywords"]    = $GLOBALS["settings"]["keywords"];
	}//if

}//build_meta

function build_javascript(){

	global $page_details;

	$info = $GLOBALS["Member"]->info();

	$sql_query = "SELECT onload,code FROM javascripts WHERE (page='all' OR page='".$page_details["items_file"]."') AND theme='".$GLOBALS["THEME"]."'";
	$result = $GLOBALS["DB"]->result($sql_query);
	$script = "";
	$onload = "";
	foreach($result as $res){
		$script.= $res["code"];
		$onload.= $res["onload"];
	}//foreach

	$script = handle_js_patterns($script);
	$onload = handle_js_patterns($onload);

	$script.= $page_details["code"];
	$onload.= ";".$page_details["onload"];

	$GLOBALS["smarty"]->assign("javascript",$script);
	$GLOBALS["smarty"]->assign("onload",$onload);

}//build_javascript

function build_tip($page_code){

	$sql_query = "SELECT message FROM tips WHERE page='".$page_code."' AND theme='".$GLOBALS["THEME"]."'";
	$tip = handle_system_messages_patterns( $GLOBALS["DB"]->single($sql_query) );

	$GLOBALS["smarty"]->assign("tip_message",$tip);

}//build_tip

function build_form($form_name,$id_val=0){

	include_once(DOC_ROOT."/functions/form_functions.php");

	global $forms;

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/forms/".$form_name.".inc.php");

	if($form["src"] == "db/get"){
		form_handle_input($form_name,0);
	}//if

	if($form["src"] == 'db'){
		form_get_from_db($form_name,$form["assoc"],$form["id"],$id_val,1);
	}//if

	if($form["src"] == 'db/get'){
		form_get_from_db($form_name,$form["assoc"],$form["id"],$id_val,0);
	}//if

	form_get_hidden($form_name);

	$forms[$form_name]["start"] = $form["start"];

	foreach($form["hidden"] as $name){

		$data["name"]  = $name;
		$data["value"] = $forms[$form_name]["values"][$name];
		if(!extract_null_value($data["value"]))
		$forms[$form_name]["start"].= build_field("hidden",$data);

	}//foreach

	while(list($i,) = each($form["names"])){

		if(in_array( $form_name, array ( 	"videos_upload",
											"edit_video" ) ) && $form["names"][$i] == "tags" ) {

			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/tags.inc.php");
			if(!$tags["enabled"])
				continue;
		}

		$items = explode("|",$form["fields"][$i]);
		$type = array_shift($items);

		$data["name"]  = $form["names"][$i];
		$data["value"] = ($data["name"] == "tags") ? trim(preg_replace("/\|/"," ",$forms[$form_name]["values"][$data["name"]])) : $forms[$form_name]["values"][$data["name"]];
		$data["dets"]  = $items;

		if($type != "SKIP"){
			$forms[$form_name]["nelements"][$data["name"]] = build_field($type,$data);
			$forms[$form_name]["elements"][$i] = $forms[$form_name]["nelements"][$data["name"]];
			$forms[$form_name]["names"][$i] = $data["name"];
		}//if
		$forms[$form_name]["labels"][$i] = $form["labels"][$i];
		$forms[$form_name]["types"][$i]   = $type;

	}//while

	while(list($i,) = each($form["txt_buttons"])){

		$data["text"] = $form["txt_buttons"][$i];

		switch($form["but_action"][$i]){

			case 'submit':
				$type = "text_submit";
				$data["onclick"] = $form["but_onclick"][$i];
				$data["name"] = $form_name."_".$i;
				break;

			case 'button':
				$type = "text_button";
				$data["onclick"] = $form["but_onclick"][$i];
				$data["name"] = $form_name."_".$i;
				break;

			case 'linked':
				$type = "text_linked";
				if($form["but_onclick"][$i] == 'REFERER'){
					if(empty($forms[$form_name]["values"]["ret_link"]))
						$form["but_onclick"][$i] = $GLOBALS["Get"]->referer();
					else
						$form["but_onclick"][$i] = stripslashes(html_entity_decode($forms[$form_name]["values"]["ret_link"]));
				}//if
				$data["name"] = $form_name."_".$i;
				$data["link"] = "window.location='".$form["but_onclick"][$i]."'";
				break;

		}//switch

		$forms[$form_name]["buttons"][$i] = build_field($type,$data);

	}//while

	$forms[$form_name]["end"] = $form["end"];

}//build_form

function rebuild_form_item($form_name,$field_name){

	global $forms;

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/forms/".$form_name.".inc.php");

	$i = array_search($field_name,$form["names"]);

	$items = explode("|",$form["fields"][$i]);
	$type = array_shift($items);

	$data["name"]  = $form["names"][$i];
	$data["value"] = $forms[$form_name][values][$data["name"]];
	$data["dets"]  = $items;

	if($type != "SKIP"){
		$forms[$form_name]["nelements"][$data["name"]] = build_field($type,$data);
		$forms[$form_name]["elements"][$i] = $forms[$form_name]["nelements"][$data["name"]];
		$forms[$form_name]["names"][$i] = $data["name"];
	}//if
	$forms[$form_name]["labels"][$i] = $form["labels"][$i];
	$forms[$form_name]["types"][$i]  = $type;

}//rebuild_form_item

function build_menu($menu_file){
	
	$menus = array();

	$info = $GLOBALS["Member"]->info();

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/page_groups.inc.php");	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/menus/".$menu_file.".inc.php");
	
	$menu_name = hs_strtolower($menu["name"]);
	$menu_name = hs_ereg_replace(" ","_",$menu_name);
	
	foreach($menu["items"] as $key => $val) {
		if($val["group"]){
			$group_pages = array();
			$group_pages = handle_empties(explode(",",$page_groups[$val["group"]]["pages"]));
			if(in_array($GLOBALS["page_details"]["items_file"],$group_pages)){
				$menus[$menu_name]["on"] = $key;
			}//if
		}//if
		if( ($val["page"]) && ($GLOBALS["page_details"]["items_file"] == $val["page"]) ){
				$menus[$menu_name]["on"] = $key;
		}//if
		$menus[$menu_name]["items"][$key] = handle_menu_patterns(handle_special_menu_item($val["name"]));
		
		
		if(!hs_ereg("^3RDPARTY;;",$val["link"])){
			preg_match_all("/\{[^\}]*\}/",$val["link"],$occurancies);
			$matches = array ();
			foreach($occurancies as $occurance){
				foreach($occurance as $longmatch){
					$matches[] = hs_substr($longmatch,1,hs_strlen($longmatch)-2);
				}//foreach
			}//foreach
			foreach($matches as $match){
				if($match == "channel_link") {
					$u = $GLOBALS["Get"]->val("u");
					if(!$u)
						$u = $info["username"];
					$val["link"] = hs_ereg_replace("\{".$match."\}",build_channel_link($u, 1),$val["link"]);
				} elseif($match == "my_channel_link") {
					$u = $info["username"];
					$val["link"] = hs_ereg_replace("\{".$match."\}",build_channel_link($u, 1),$val["link"]);
				} elseif($match == "url") {
					$val["link"] = hs_ereg_replace("\{".$match."\}",extract_mainurl_relative(),$val["link"]);
				} else {
					$val["link"] = hs_ereg_replace("\{".$match."\}",$GLOBALS["Get"]->val($match),$val["link"]);
				}
			}//foreach
			$menus[$menu_name]["links"][$key] = $val["link"];
		}//if
		else{
			$script_id = hs_substr($val["link"],hs_strrpos($val["link"],";")+1,1);
			$menus[$menu_name]["links"][$key] = load_3rdparty("link",array(),$script_id);
			$menus[$menu_name]["target"][$key] = "_blank";
		}//else
		
		if($menu_name == "subvideos") {
			$val = $GLOBALS["Get"]->val("type");
			if(!$val){$val = "recent";}
			if(strstr( $menus[$menu_name]["links"][$key], $val ))
				$menus[$menu_name]["on"] = $key;
		}
		
		if($menu_name == "subgroups") {
			$val = $GLOBALS["Get"]->val("type");
			if(!$val){$val = "videos";}
			if(strstr( $menus[$menu_name]["links"][$key], $val ))
				$menus[$menu_name]["on"] = $key;
		}
		
		if($menu_name == "subchannels") {
			$val = $GLOBALS["Get"]->val("type");
			if(!$val){$val = "viewed";}
			if(strstr( $menus[$menu_name]["links"][$key], $val ))
				$menus[$menu_name]["on"] = $key;
		}
	}

	reset($menus[$menu_name]);
	foreach($menus[$menu_name]["items"] as $key => $val) {
		if(extract_null_value ($val )) {
			unset($menus[$menu_name]["items"][$key]);
			unset($menus[$menu_name]["links"][$key]);
			unset($menus[$menu_name]["target"][$key]);
		}
	}

	$GLOBALS["menus"][$menu_name] = $menus[$menu_name];

}//build_menu

function build_output($page, $popup){

	global $layout;

	include(DOC_ROOT."/includes/themes.inc.php");

	$info = $GLOBALS["Member"]->info();

	if($page == "channels")
		$GLOBALS["smarty"]->display("pubheader.tpl");
	elseif($popup == 1)
		$GLOBALS["smarty"]->display("header_popup.tpl");
	else
		$GLOBALS["smarty"]->display("header.tpl");

	$GLOBALS["smarty"]->display("pages/".$page.".tpl");

	if($page == "channels")
		$GLOBALS["smarty"]->display("pubfooter.tpl");
	elseif($popup == 1)
		$GLOBALS["smarty"]->display("footer_popup.tpl");
	else
    	$GLOBALS["smarty"]->display("footer.tpl");

}//build_output

function build_field($type,$data,$theme=0){

	if(!$theme)
		$theme = $GLOBALS["THEME"];

	include(DOC_ROOT."/includes/themes.inc.php");

	extract($data);
	if(!is_array($value))
	$value = stripslashes($value);

	switch($type){

		case 'hidden':
			if(!is_array($value))
			$output = "<input type=\"hidden\" name=\"".$name."\" value=\"".$value."\">";
			else{
				$output = "";
				while(list($key,$val) = each($value)){
					$output.= "<input type=\"hidden\" name=\"".$name."[".$key."]\" value=\"".$val."\">";
				}//while
			}//else
			break;

		case 'textfield':
			if($dets[1] && empty($value)){
				include(DOC_ROOT."/themes/".$theme."/invitations.inc.php");
				$value = $invitations[$dets[2]]["subject"];
				$info = $GLOBALS["Member"]->info();
				$value = hs_ereg_replace("\|member\|",$GLOBALS["Member"]->username($info["mem_id"]),$value);
			}//if
			
			if(strstr( $dets[0], "px" ))
				$size = "style='width:".$dets[0]."'";
			else
				$size = "size='".$dets[0]."'";

			$output = "<input class=\"textfield\" type=\"text\" ".$size." name=\"".$name."\" value=\"".$value."\">";
			break;

		case 'textfield_set':
			$name.= "[]";
			$output = "";
			if(!is_array($value)){
				if(hs_eregi("^".preg_quote("&#124;"),$value))
					$value = hs_ereg_replace(preg_quote("&#124;"),"|",$value);
				$value = handle_empties(explode("|",$value));
			}//if
			
			if(strstr( $dets[0], "px" ))
				$size = "style='width:".$dets[0]."'";
			else
				$size = "size='".$dets[0]."'";
				
			if($dets[2])
				$output.= "<fieldset>";

			for($i=0;$i<$dets[1];$i++){
				$val = $value[$i];
				if($dets[2])
					$output.= "<div class=\"formSet\">";
				$output.= "<input class=\"textfield\" type=\"text\" ".$size." name=\"".$name."\" value=\"".$val."\"> ";
				if($dets[2])
					$output.= "</div>";
			}//for
			
			if($dets[2])
				$output.= "</fieldset>";

			break;

		case 'passfield':
			if(strstr( $dets[0], "px" ))
				$size = "style='width:".$dets[0]."'";
			else
				$size = "size='".$dets[0]."'";
			$output = "<input class=\"textfield\" type=\"password\" ".$size." name=\"".$name."\">";
			break;

		case 'checkbox':
			if($value || $dets[0]){
				$checked = "checked";
			}//if
			$output = "<input class=\"checkbox\" type=\"checkbox\" name=\"".$name."\" value=\"1\" ".$checked.">";
			break;

		case "text_submit":
			$output = "<input name=\"".$name."\" id=\"".$name."\" class=\"button\" type=\"submit\" name=\"submit\" value=\"".$data["text"]."\" onclick=\"".$data["onclick"]."\">";
			break;

		case "text_button":
			$output = "<input name=\"".$name."\" id=\"".$name."\" class=\"button\" type=\"button\" value=\"".$data["text"]."\" onclick=\"".$data["onclick"]."\">";
			break;

		case "text_linked":
			$output = "<input name=\"".$name."\" id=\"".$name."\" class=\"button\" type=\"button\" value=\"".$data["text"]."\" onclick=\"".$data["link"]."\">";
			break;

		case 'options':
			if($dets[3])
				$options[""] = $GLOBALS["language"]["please_select"];
			include(DOC_ROOT."/themes/".$theme."/options/".$dets[0].".inc.php");
			$default = $dets[1];
			$multiple = $dets[2];
			$additional = $dets[4];
			if($multiple){
				if(hs_eregi("^".preg_quote("&#124;"),$value))
					$value = hs_ereg_replace(preg_quote("&#124;"),"|",$value);
				$value = hs_ereg_replace(preg_quote("&#124;"),"|",$value);
			}//if
			$output = build_options_list($name,$options,$value,$default,$multiple,$additional);
			break;

		case 'countries':
			$options = array();

			if(!$value)
				$value = "";

			if($dets[1])
				$options[0] = $GLOBALS["language"]["please_select"];
			else
				$dets[1] = 0;
			$sql_query = "SELECT * FROM geo_countries ORDER BY name";
			$result = $GLOBALS["DB"]->result($sql_query);
			foreach($result as $res){
				$options[$res["con_id"]] = $res["name"];
			}//foreach
			$default = $dets[0];
			if(empty($value))
				$country = $default;
			else
				$country = $value;

			$output = build_options_list($name,$options,$value,$default,0,"style='width:180px;'");
			break;
			
		case 'group_url':
			$url = extract_groups_base_url();
			if(strstr( $dets[0], "px" ))
				$size = "style='width:".$dets[0]."'";
			else
				$size = "size='".$dets[0]."'";

			$output = $url." <input class=\"textfield\" type=\"text\" ".$size." name=\"".$name."\" value=\"".$value."\">";
			break;

		case 'categories':
			include(DOC_ROOT."/themes/".$theme."/system/".$dets[0].".inc.php");
			asort($categories);
			if($dets[1])
				$options[""] = $GLOBALS["language"]["please_select"];
			else
				$dets[1] = 0;
			$category = $value;
			while(list($key,$val) = each($categories)){
				$options[$key] = $val;
			}//while
			if(!$dets[2])
				$output = build_options_list($name,$options,$value,$default,0,"style='width:180px;'");
			else
				$output = build_options_list($name,$options,$value,$default,1,"style='width:180px;height:150px;'");
			break;

		case 'payment_type':
			include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
			$options = array();
			while(list($key,$val) = each($getpaid["systems"])){
				$options[$key] = $val["name"];
			}//while
			$output = build_options_list($name,$options,$value,1);
			break;

		case 'radio':
			$options = array();
			include(DOC_ROOT."/themes/".$theme."/options/".$dets[0].".inc.php");
			$default = $dets[1];
			if(extract_null_value($value)){
				$value = $default;
			}//if
			$output = "";

			if($dets[2])
				$output.= "<fieldset>";

			while(list($key,$val) = each($options)){
				if($dets[2])
					$output.= "<div class=\"formSet\">";
				$output.= "<input class=\"radio\" type=\"radio\" name=\"".$name."\" value=\"".$key."\"";
				if($key == $value){
					$output.= " checked";
				}//if
				$output.= ">".$val." ";
				if($dets[2])
					$output.= "</div>";
			}//while

			if($dets[2])
				$output.= "</fieldset>";

			break;

		case 'membership_level':
			include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
			$switches = array();
			while(list($key,$val) = each($getpaid["membership"])){
				if($val["price"] > 0){
				$switches[$key] = $val["name"]." ".extract_package_price($val["price"],$val["currency"],$val["interval"],$val["period"]);
				}//if
			}//while
			$output = "";
			$output.= "<fieldset>";
			while(list($key,$val) = each($switches)){
				$output.= "<div class=\"formSet\">";
				$output.= "<input class=\"radio\" type=\"radio\" name=\"".$name."\" value=\"".$key."\"";
				if($key == 1){
					$output.= " checked";
				}//if
				$output.= ">".$val." ";
				$output.= "</div>";
			}//while
			$output.= "</fieldset>";
			break;

		case 'set':
			include(DOC_ROOT."/themes/".$theme."/options/".$dets[0].".inc.php");
			$output = "";
			if(hs_eregi("^".preg_quote("&#124;"),$value))
				$value = hs_ereg_replace(preg_quote("&#124;"),"|",$value);
			$value = explode("|",$value);
			$value = handle_empties($value);
			while(list($key,$val) = each($options)){
				$output.= "<input class=\"checkbox\" type=\"checkbox\" name=\"".$name."[]\" value=\"".$key."\"";
				if(in_array($key,$value))
					$output.= " checked";
				$output.= ">".$val." ";
			}//while
			break;

		case 'date':
			$vals["value"] = $value;
			$vals["name"] = $name;
			$vals["future"] = $dets[1];
			$vals["start_year"] = $dets[2];
			$vals["end_year"] = $dets[3];
			$output = build_date($vals);
			break;

		case 'date_time':
			$vals["prefix"] = $dets[0];
			$vals["value"] = $value;
			$output = build_date_time($vals);
			break;

		case 'time':
			$vals["name"] = $name;
			$vals["prefix"] = $dets[0];
			$vals["value"] = $value;
			$output = build_time($vals);
			break;

		case 'file':
			$output = "<input type=\"file\" class=\"textfield\" name=\"".$name."\" size=\"".$dets[0]."\">";
			break;

		case 'textarea':
			if($dets[2] && empty($value)){
				include(DOC_ROOT."/themes/".$theme."/invitations.inc.php");
				$value = $invitations[$dets[3]]["body"];
				$info = $GLOBALS["Member"]->info();
				$value = hs_ereg_replace("\|member\|",$GLOBALS["Member"]->username($info["mem_id"],1),$value);
			}//if
			
			if(strstr( $dets[0], "px" ))
				$size = "style='height:".$dets[0].";width:".$dets[1]."'";
			else
				$size = "rows='".$dets[0]."' cols='".$dets[1]."'";
			
			$output = "<textarea class=\"textarea\" name=\"".$name."\" ".$size.">".$value."</textarea>";
			break;

		case 'import_services':
			$services = array("yahoo","gmail","hotmail","msn","myspace");
			if(empty($value))
				$value = "yahoo";

			$output = "<table cellpadding=\"0\" cellspacing=\"2\" border=\"0\"><tr>";
			foreach($services as $service){
				$output.= "<tr><td width=\"30\"><input type=\"radio\" name=\"".$name."\" value=\"".$service."\"";
				if($service == $value)
					$output.= " checked";
				$output.= "></td><td>";
				list($width,$height) = getimagesize(DOC_ROOT."/themes/".$theme."/gfx/icons/services/".$service.".gif");
				$output.= "<img src=\"".URL."/themes/".$theme."/gfx/icons/services/".$service.".gif\" width=\"".$width."\" height=\"".$height."\" border=\"0\">";
				$output.= "</td></tr>";
			}//foreach
			$output.= "</tr></table>";
			break;
			
		case 'playlists':
			$info = $GLOBALS["Member"]->info();
			$sql_query = "SELECT pla_id,title FROM playlists WHERE mem_id=".$info["mem_id"]."
						  AND privacy=0
						  ORDER BY title ASC";
			$result = $GLOBALS["DB"]->result( $sql_query );
			$options = array();
			$options[""] = $GLOBALS["language"]["please_select"];
			foreach($result as $res) {
				$options[$res["pla_id"]] = $res["title"];
			}
			if($dets[0])
				$options["new"] = $GLOBALS["language"]["new_playlist"];
			if($dets[1])
				$multiple = 1;
			else
				$multiple = 0;
			$output = build_options_list($name,$options,$value,-1,$multiple,"style='width:180px;'");
			break;
			
		case 'videos':
			$info = $GLOBALS["Member"]->info();
			$options = array();
			$options[""] = $GLOBALS["language"]["please_select"];
			$options[-1] = $GLOBALS["language"]["my_videos"];
			$sql_query = "SELECT vid_id, title FROM videos WHERE mem_id=".$info["mem_id"]." ORDER BY title ASC";
			$result = $GLOBALS["DB"]->result( $sql_query );
			foreach($result as $res) {
				$options[$res["vid_id"]] = "&nbsp;&nbsp;".handle_string_cut( $res["title"], 30 );
			}
			$options[-2] = $GLOBALS["language"]["my_favorites"];
			$sql_query = "SELECT v.vid_id, v.title FROM videos AS v, bookmarks AS b WHERE b.mem_id=".$info["mem_id"]."
						  AND v.mem_id != ".$info["mem_id"]."
						  AND b.item_id = v.vid_id ORDER BY v.title ASC";
			$result = $GLOBALS["DB"]->result( $sql_query );
			foreach($result as $res) {
				$options[$res["vid_id"]] = "&nbsp;&nbsp;".handle_string_cut( $res["title"], 30 );
			}
			$output = build_options_list($name,$options,$value,0,0,"style='width:180px;'");
			break;
			
		case 'color_schemes':
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/color_schemes.inc.php");
			$output = "<div>";
			foreach($scheme as $key => $val) {
				$output.= "<div style=\"float: left; padding: 10px; text-align: center\">
				<img src=\"".URL."/themes/".$GLOBALS["THEME"]."/gfx/schemes/".$key.".gif\" width=\"30\" height=\"29\" border =\"0\"><br />
				<input type=\"radio\" name=\"theme\" value=\"".$key."\"";
				if($value == $key)
					$output.= " checked ";
				$output.= ">
				</div>";
			}
			$output.= "</div>";
			break;
			
		case 'invitees_box':
			$info = $GLOBALS["Member"]->info();
			$output = array();
			$friends = $GLOBALS["Network"]->friends( $info["mem_id"], array(0, 500) );
			
			$options = array();
			foreach($friends as $fr) {
				$options[$fr] = $GLOBALS["Member"]->username( $fr );
			}
			
			$output["friends"]  = build_options_list( "invitees_box_friends", $options, 0, 0, 1, "style='width:200px;height:150px'" );
			$output["invitees"] = build_options_list( "invitees", array(), 0, 0, 1, "style='width:200px;height:150px'" );
						
			break;

	}//switch

	return $output;

}//build_field

function build_time($vals){

	include_once(DOC_ROOT."/functions/adodb-time.php");

	extract($vals);

	if(is_array($value)){
		$hour   = $value[0];
		$minute = $value[1];
		$ampm   = $value[2];
	}//is
	elseif(!extract_null_value($value)){
		$hour   = adodb_date("G",$value);
		$minute = adodb_date("i",$value);
		$ampm   = adodb_date("a",$value);
		$ampm   = ($ampm == "am") ? 1 : 2;
	}//elseif

	if(extract_null_value($hour))
		$hour = -1;

	if(extract_null_value($minute))
		$minute = -1;

	$fields_order = explode("/",$GLOBALS["settings"]["date_fields_order"]);
	if(in_array("ampm",$fields_order)){
		$hour_end = 12;
		if($hour > 12)
			$hour-= 12;
	}//if
	else{
		$hour_end = 23;
	}//else

	$hours[""] = $GLOBALS["language"]["Hour"];
	for($i=0;$i<=$hour_end;$i++){
		if($i<10)
			$hours[$i] = "0".$i;
		else
			$hours[$i] = $i;
	}//for

	$minutes[""] = $GLOBALS["language"]["Minute"];
	for($i=0;$i<=59;$i++){
		if($i<10)
			$minutes[$i] = "0".$i;
		else
			$minutes[$i] = $i;
	}//for

	$ampms[1] = "AM";
	$ampms[2] = "PM";

	$names = array(
		"hour"   => $name."[0]",
		"minute" => $name."[1]",
		"ampm"   => $name."[2]"
	);

	$options = array(
		"hour"   => $hours,
		"minute" => $minutes,
		"ampm"   => $ampms
	);

	$selects = array(
		"hour"   => $hour,
		"minute" => $minute,
		"ampm"   => $ampm
	);

	$output = "";

	foreach($fields_order as $ord){
		if($ord == "hour" || $ord == "minute" || $ord == "ampm")
			$output.= build_options_list($names[$ord],$options[$ord],$selects[$ord])."&nbsp;";
	}//foreach

	return $output;

}//build_time

function build_date_time($vals){

	include_once(DOC_ROOT."/functions/adodb-time.php");

	extract($vals);

	if(is_array($value)){
		$day    = $value[0];
		$month  = $value[1];
		$year   = $value[2];
		$hour   = $value[3];
		$minute = $value[4];
		$ampm   = $value[5];
	}//is
	elseif(!extract_null_value($value)){
		$day    = adodb_date("j",$value);
		$month  = adodb_date("n",$value);
		$year   = adodb_date("Y",$value);
		if(date("s",$value) == 0){
			$hour   = adodb_date("G",$value);
			$minute = adodb_date("i",$value);
			$ampm   = adodb_date("a",$value);
			$ampm   = ($ampm == "am") ? 1 : 2;
		}//if
	}//elseif

	$fields_order = explode("/",$GLOBALS["settings"]["date_fields_order"]);
	if(in_array("ampm",$fields_order)){
		$hour_end = 12;
		if($hour > 12)
			$hour-= 12;
	}//if
	else{
		$hour_end = 23;
	}//else

	if(extract_null_value($hour))
		$hour = -1;

	if(extract_null_value($minute))
		$minute = -1;

	$name = $prefix."date";

	$days[""] = $GLOBALS["language"]["Day"];

	for($i=1;$i<=31;$i++) {

		if($i<10){

			$days[$i] = "0".$i;

		}//if
		else{

			$days[$i] = $i;

		}//else

	}//for

	$years[""] = $GLOBALS["language"]["Year"];

	$curr_year = date("Y");
	for($j=$curr_year;$j<=$curr_year+5;$j++){

		$years[$j] = $j;

	}//for

	$months[""] = $GLOBALS["language"]["Month"];
	$months_line = "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec";
	$months_arr = explode(",",$months_line);
	while(list($key,$val) = each($months_arr)){
		$months[$key+1] = $GLOBALS["language"][$val];
	}//while

	$hours[""] = $GLOBALS["language"]["Hour"];
	for($i=0;$i<=$hour_end;$i++){
		if($i<10)
			$hours[$i] = "0".$i;
		else
			$hours[$i] = $i;
	}//for

	$minutes[""] = $GLOBALS["language"]["Minute"];
	for($i=0;$i<=59;$i++){
		if($i<10)
			$minutes[$i] = "0".$i;
		else
			$minutes[$i] = $i;
	}//for

	$ampms[1] = "AM";
	$ampms[2] = "PM";

	$names = array(
		"day"    => $name."[0]",
		"month"  => $name."[1]",
		"year"   => $name."[2]",
		"hour"   => $name."[3]",
		"minute" => $name."[4]",
		"ampm"   => $name."[5]"
	);

	$options = array(
		"day"    => $days,
		"month"  => $months,
		"year"   => $years,
		"hour"   => $hours,
		"minute" => $minutes,
		"ampm"   => $ampms
	);

	$selects = array(
		"day"   => $day,
		"month" => $month,
		"year"  => $year,
		"hour"   => $hour,
		"minute" => $minute,
		"ampm"   => $ampm
	);

	$output = "";

	foreach($fields_order as $ord){
		if($ord != "-")
			$output.= build_options_list($names[$ord],$options[$ord],$selects[$ord])."&nbsp;";
	}//foreach

	return $output;

}//build_date_time

function build_date($vals){

	include_once(DOC_ROOT."/functions/adodb-time.php");

	extract($vals);

	if(is_array($value)){
		$day   = $value[0];
		$month = $value[1];
		$year  = $value[2];
	}//if
	elseif(!extract_null_value($value) && ($value > 0 || $value < 0)){
		$day   = adodb_date("j",$value);
		$month = adodb_date("n",$value);
		$year  = adodb_date("Y",$value);
	}//else

	$fields_order = explode("/",$GLOBALS["settings"]["date_fields_order"]);

	$days[""] = $GLOBALS["language"]["Day"];

	for($i=1;$i<=31;$i++) {

		if($i<10){

			$days[$i] = "0".$i;

		}//if
		else{

			$days[$i] = $i;

		}//else

	}//for

	$years[""] = $GLOBALS["language"]["Year"];

	if(!$start_year || !$end_year){
		if(!$future){
			$start_year = date("Y")-$GLOBALS["settings"]["min_member_age"];
			$end_year   = date("Y")-80;
		}//if
		else{
			$start_year = date("Y");
			$end_year   = date("Y")+5;
		}//else
	}//if
	else {
		if($start_year == "now")
			$start_year = date("Y");
		if(preg_match("/^[\+|-]/", $end_year)) {
			$end_year = $start_year + $end_year;
		}
	}

	if($start_year > $end_year){
		for($j=$start_year;$j>=$end_year;$j--){
			$years[$j] = $j;
		}//for
	}//if
	else{
		for($j=$start_year;$j<=$end_year;$j++){
			$years[$j] = $j;
		}//for
	}//else

	$months[""] = $GLOBALS["language"]["Month"];
	$months_line = "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec";
	$months_arr = explode(",",$months_line);
	while(list($key,$val) = each($months_arr)){
		$months[$key+1] = $GLOBALS["language"][$val];
	}//while

	$names = array(
		"day"   => $name."[0]",
		"month" => $name."[1]",
		"year"  => $name."[2]"
	);

	$options = array(
		"day"   => $days,
		"month" => $months,
		"year"  => $years
	);

	$selects = array(
		"day"   => $day,
		"month" => $month,
		"year"  => $year
	);

	$output = "";

	foreach($fields_order as $ord){
		if($ord == "day" || $ord == "month" || $ord == "year")
			$output.= build_options_list($names[$ord],$options[$ord],$selects[$ord])."&nbsp;";
	}//foreach

	return $output;

}//build_date

function build_options_list($name,$options,$value=0,$default=0,$multiple=0,$additional=""){

	if(!is_array($options))
		$options = array();

	if(extract_null_value($value)){
		$value = $default;
	}//if

	if($multiple){
		$name.= "[]";
		$value = handle_empties(explode("|",$value));
	}//if
	
	$class = "dropdown";
	if($multiple)
		$class.= "_multiple";

	$output = "<select class=\"".$class."\" name=\"".$name."\" ";
	if($multiple){
		$output.= " multiple ";
	}//if
	$output.= $additional." >";

	while(list($key,$val) = each($options)){
		$output.= "<option value=\"".$key."\"";
		if((!$multiple && $value == $key) || ($multiple && in_array($key,$value))){
			$output.= " selected";
		}//if
		$output.= ">".$val."</option>";
	}//while

	$output.= "</select>";

	return $output;

}//build_dropdown

function build_sep_line($haystack,$sep){

	$line = $sep;

	if(is_array($haystack)){
		$line.= implode($sep,$haystack).$sep;
	}//if

	return $line;

}//build_sep_line

function build_verification_key(){

	mt_srand((double) microtime() * 100000);

	$exist = 1;

	while($exist != 0){

		$rand = mt_rand(0,10000);
		$key  = hs_substr(md5($rand.time()),0,6);

		$sql_query="SELECT count(*)
					FROM verification
					WHERE val=':0:'";

		$GLOBALS["DB"]->values = array($key);
		$exist = $GLOBALS["DB"]->single($sql_query);

	}//while

	return $key;

}//build_verification_key

function build_error($err_id,$err_page,$err_section='',$ajax=0){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/errors.inc.php");

	$err_message = handle_system_messages_patterns( $errors[$err_id] );

	$GLOBALS["status"] = "error";
	$GLOBALS["smarty"]->assign("status","error");
	$GLOBALS["smarty"]->assign("system_message",$err_message);
	
	if($ajax) {
		return $GLOBALS["smarty"]->display("ajax/system.tpl");
	}

	if($err_page !== -1){
		$p_details["page"] = $err_page;
		$p_details["section"] = $err_section;
		$p_details["items_file"] = (empty($p_details["section"])) ? $p_details["page"] : $p_details["page"]."_".$p_details["section"];
		build_page($p_details, $GLOBALS["page_details"]["popup"]);
		exit;
	}//if

}//build_error

function build_complete($cmp_id, $ajax=0){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/completes.inc.php");

	$GLOBALS["status"] = "complete";
	$GLOBALS["smarty"]->assign("status","complete");
	$GLOBALS["smarty"]->assign("system_message",handle_system_messages_patterns( $completes[$cmp_id] ));
	
	if($ajax)
		return $GLOBALS["smarty"]->display("ajax/system.tpl");

}//build_complete

function build_banner($params){

	global $page_details;

	extract($params);

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/ads.inc.php");

	if($area && in_array($area,@array_keys($ads["areas"]))){

		$info    = $GLOBALS["Member"]->info();
		$country = $info["country"];
		$page    = $page_details["items_file"];
		$module  = $page_details["page"];
		$formats = explode(",",$ads["areas"][$area][formats]);

		$campaigns = extract_available_campaigns();

		$sql_query = "SELECT ban_id FROM banners,campaigns WHERE banners.cmp_id=campaigns.cmp_id
					  AND campaigns.`status`='1' AND areas LIKE '%,".$area.",%'
					  AND campaigns.theme='".$GLOBALS["THEME"]."'
					  AND (pages='all' OR pages LIKE '%,".$page.",%')
					  AND banners.cmp_id IN (".implode(",",$campaigns).")";

		if($country)
			$sql_query.= " AND (countries='all' OR countries LIKE ',%".$country."%,')";
		else
			$sql_query.= " AND countries='all'";

		switch($module){
			case 'videos':
				$id_name = "vid_id";
				$id = $GLOBALS["Get"]->type_val("vid_id","integer");
				$table   = "videos";
				$setting = "video_categories";
				break;
			case 'groups':
				$id_name = "grp_id";
				$g = $GLOBALS["Get"]->val("g");
				$id = $GLOBALS["Get"]->type_val("grp_id","integer");
				
				if($g) {
					$q = "SELECT grp_id FROM groups WHERE folder=':g:'";
					$GLOBALS["DB"]->values = array( "g" => $g );
					$id = $GLOBALS["DB"]->single( $q );
				}
				$table   = "groups";
				$setting = "group_categories";
				break;
		}//switch

		if($id && $table && $setting){
			$category = $GLOBALS["Get"]->type_val("c","integer");
			if(!$category){
				if($id){
					$sql_query2 = "SELECT category FROM ".$table."
								   WHERE ".$id_name."=".$id;
					$result = $GLOBALS["DB"]->row($sql_query2);
					$category = $result["category"];
				}//if
			}//if

			if($category)
				$sql_query.= " AND (".$setting."='all' OR ".$setting." LIKE '%,".$category.",%')";

		}//if

		$sql_query.= " ORDER BY last_shown ASC";

		$banner = $GLOBALS["DB"]->single($sql_query);

		if($banner){
			$sql_query = "UPDATE banners SET impressions=impressions+1,last_shown=".time()."
						  WHERE ban_id=".$banner;
			$GLOBALS["DB"]->execute($sql_query);

			if(!$preload)
				echo extract_banner_output($banner);
			else
				return true;
		}//if

	}//if

}//build_banner

function build_keywords($text){

	$text = preg_replace("/\r|\n|\t| /"," ",$text);
	$text = preg_replace("/[\$|#|&|@|\!|\(|\)|-|\{|\}|'|`|_|~|\.|,]/"," ",$text);
	$text = ereg_replace("[ ]+"," ",$text);

	$words = explode(" ",$text);
	$words = array_unique($words);
	$words = handle_empties($words);

	$keywords = implode(", ",$words);

	return $keywords;

}//build_keywords

function build_screenshot($video, $hash, $length){
	
	include_once(DOC_ROOT."/functions/converter/".CONVERTER.".php");

	mt_srand((double) microtime() * 100000);
	$tmpdir = DOC_ROOT."/scr/".substr( $hash, 0, strrpos( $hash, "/" ) );
	
	//screenshots timestamps
	$part_duration = $length / ($GLOBALS["Videos"]->screenshots - 1);
	$tstamp[1] = 1;
	for( $i = 2; $i < $GLOBALS["Videos"]->screenshots; $i++ ){
		$tstamp[$i] = $part_duration * ($i - 1);
	}
	$last = $GLOBALS["Videos"]->screenshots;
	$tstamp[$last] = $length - 1;
	
	//get screenshots
	foreach( $tstamp as $key => $val ) {
		$file = converter_screenshot( $video, $val, $tmpdir );		
		if(!file_exists($file)){
			return false;
		}
		else {
			rename( $file, DOC_ROOT."/scr/".$hash."_".$key.".jpg");
			copy( DOC_ROOT."/scr/".$hash."_".$key.".jpg", DOC_ROOT."/scr/".$hash."_".$key."_b.jpg" );
			handle_image_resize( DOC_ROOT."/scr/".$hash."_".$key.".jpg", $GLOBALS["Videos"]->screenshot_width, $GLOBALS["Videos"]->screenshot_height, ".jpeg", 1, 1 );
		}
	}
	return true;

}//build_screenshot

function build_unique_path( $base, $ext ) {
	mt_srand((double) microtime() * 100000);
	
	$path = "";
	
	while( !$path || file_exists( $base."/".$path.$ext ) ) {
		$file = hs_substr(md5(time().mt_rand(0,100)),0,15);

		$folder = substr($file,0,2);
		if(!file_exists($base."/".$folder))
			mkdir($base."/".$folder,PERMISSIONS);
	
		$folder.= "/".substr($file,2,2);
		if(!file_exists($base."/".$folder))
			mkdir($base."/".$folder,PERMISSIONS);
	
		$folder.= "/".substr($file,4,2);
		if(!file_exists($base."/".$folder))
			mkdir($base."/".$folder,PERMISSIONS);
	
		$path = $folder."/".$file;
	}
	return $path;
}

function build_channel_link( $username, $ending = 0 ){
	if($GLOBALS["settings"]["mod_rewrite"]) {
		if($ending)
			$add = "?";
		return URL."/".$username.$add;
	} else {
		if($ending)
			$add = "&";
		return URL."/?u=".$username.$add;
	}
}

function build_channel_link_by_id( $mem_id, $ending = 0 ){
	$sql_query = "SELECT username FROM members WHERE mem_id=".$mem_id;
	$username = $GLOBALS["DB"]->single( $sql_query );
	return build_channel_link( $username, $ending );
}

function build_group_link( $folder, $ending = 0 ){
	if($GLOBALS["settings"]["mod_rewrite"]) {
		if($ending)
			$add = "?";
		return URL."/group/".$folder.$add;
	} else {
		if($ending)
			$add = "&";
		return URL."/?g=".$folder.$add;
	}
}

function build_group_link_by_id( $grp_id, $ending = 0 ){
	
	$folder = $GLOBALS["DB"]->single( "SELECT folder FROM groups WHERE grp_id=".$grp_id );
	return build_group_link( $folder, $ending );
	
}

function build_viewkey( $type, $data ) {
	
	switch($type) {
		case 'video':
			$sql_query = "SELECT broadcast FROM videos WHERE vid_id=".$data[0];
			$privacy = $GLOBALS["DB"]->single( $sql_query );
			$required = ($privacy) ? 1 : 0;
			break;
		case 'playlist':
			$sql_query = "SELECT privacy FROM playlists WHERE pla_id=".$data[0];
			$privacy = $GLOBALS["DB"]->single( $sql_query );
			$required = ($privacy) ? 1 : 0;
			break;
		case 'group':
			$sql_query = "SELECT privacy FROM groups WHERE grp_id=".$data[0];
			$privacy = $GLOBALS["DB"]->single( $sql_query );
			$required = ($privacy < 3) ? 0 : 1;
			break;
	}
	
	if(!$required)
		return "";
	
	$sql_query = "SELECT viewkey FROM viewkeys WHERE id=':id:' AND type=':type:'";
	$GLOBALS["DB"]->values = array( "id" => $data[0], "type" => $type );
	$key = $GLOBALS["DB"]->single( $sql_query );
	
	if(!$key) {
	
		$salt = "";
		foreach($data as $val) {
			$salt.= $val;
		}
		
		$salt.= time();
		$key = md5( $salt );
		
		$sql_query = "INSERT INTO viewkeys (id,type,viewkey)
					  VALUES (:id:,':type:',':key:')";
		$GLOBALS["DB"]->values = array(
			"id" => $data[0],
			"type" => $type,
			"key" => $key
		);
		$GLOBALS["DB"]->execute( $sql_query );
		
	}
	
	return $key;
	
}

function build_access( $type, $data ) {
	
	switch($type) {
		case 'video':
			$sql_query = "SELECT broadcast FROM videos WHERE vid_id=".$data[0];
			$privacy = $GLOBALS["DB"]->single( $sql_query );
			$required = ($privacy) ? 1 : 0;
			break;
		case 'playlist':
			$sql_query = "SELECT privacy FROM playlists WHERE pla_id=".$data[0];
			$privacy = $GLOBALS["DB"]->single( $sql_query );
			$required = ($privacy) ? 1 : 0;
			break;
		case 'group':
			$sql_query = "SELECT privacy FROM groups WHERE grp_id=".$data[0];
			$privacy = $GLOBALS["DB"]->single( $sql_query );
			$required = ($privacy < 3) ? 0 : 1;
			break;
	}
	
	if(!$required)
		return false;
	
	$sql_query = "SELECT COUNT(*) FROM private_access WHERE id=:0: AND mem_id=:1: AND type=':2:'";
	$GLOBALS["DB"]->values = array( $data[0], $data[1], $type );
	$exists = $GLOBALS["DB"]->single( $sql_query );
	
	if(!$exists) {
		$sql_query = "INSERT INTO private_access (id,mem_id,type)
					  VALUES (:0:,:1:,':2:')";
		$GLOBALS["DB"]->values = array( $data[0], $data[1], $type );
		$GLOBALS["DB"]->execute( $sql_query );		
	}
	
	return true;
	
}

function build_profile_field($values,$type_line,$name){

	$items = explode("|",$type_line);
	$type  = array_shift($items);

	switch($type){

		case 'yes_no':
			$ret = ($values[$name]) ? $items[0] : $items[1];
			break;

		case 'option':
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/options/".$items[0].".inc.php");
			$ret = $options[$values[$name]];
			break;

		case 'set':
			$ret = extract_set($items[0],$values[$name]);
			break;

		case 'txt_set':
			$ret = extract_txt_set($values[$name]);
			break;

		case 'txt_url_set':
			$urls = handle_empties(explode("|",$values[$name]));
			$ret = "";
			foreach($urls as $url){
				if($url != ''){
					if(!hs_eregi("^http://",$url))
						$link = "http://".$url;
					else
						$link = $url;
					$ret.= "<a target=\"_blank\" href=\"".$link."\">".$url."</a>, ";
				}//if
			}//foreach
			$ret = rtrim($ret,', ');
			break;

		case 'link':
			if($values[$name] != ''){
				if(!hs_ereg("^http://",$values[$name]))
					$link = "http://".$values[$name];
				else
					$link = $values[$name];
				$ret = "<a target=\"_blank\" href=\"".$link."\">".$values[$name]."</a>";
			}//if
			else{
				$ret = "";
			}//else
			break;

		case 'txt_block':
			$ret = nl2br($values[$name]);
			break;

		case 'text':
			$ret = $values[$name];
			break;

		case 'date':
			$ret = extract_date($values[$name]);
			break;

		case 'date_time':
			$ret = extract_time($values[$name]);
			break;

		case 'time':
			$ret = extract_time($values[$name],0);
			break;

	}//switch

	return $ret;

}

?>