<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function handle_empties($haystack,$keep_key=0){

	$result = array ();

	if(is_array($haystack)){

		while(list($key,$val) = each($haystack)){

			if(!empty($val)){

				if($keep_key){
					$result[$key] = $val;
				}//if
				else{
					$result[] = $val;
				}//else

			}//if

		}//while

	}//if

	return $result;

}//handle_empties

function handle_data_from_db($associates,$id){

	$result = array ();

	$u = $GLOBALS["Get"]->val("u");
	if($u){
		$id_val = $GLOBALS["Member"]->mem_id( $u );
	}
	
	if(!$id_val) {
		$info   = $GLOBALS["Member"]->info();
		$id_val = $info["mem_id"];
	}
	
	if(!$id_val)
		return array();

	while(list($table,$fields) = each ($associates)){

		$sql_query="SELECT ".$fields."
					FROM ".$table." WHERE ".$id."=".$id_val;

		$result = array_merge($result,$GLOBALS["DB"]->row($sql_query));

	}//while
	
	return $result;

}//handle_data_from_db

function handle_special_menu_item($code){

	if(!hs_ereg("^SPECIAL;;",$code))
		return $code;

	$info = $GLOBALS["Member"]->info();

	$details = explode(";;",$code);
	$type = $details[1];

	switch($type){
			
		case 'FRIENDSHIP':
			$u = $GLOBALS["Get"]->val("u");
			$per_id = $GLOBALS["Member"]->mem_id( $u );
			if($info["mem_id"] == $per_id)
				return "";
			$is_connected = $GLOBALS["Network"]->is_trusted($info["mem_id"],$per_id,1);
			return (!$is_connected) ? $details[2] : $details[3];
			break;

		case 'IGNORE':
			$u = $GLOBALS["Get"]->val("u");
			$per_id = $GLOBALS["Member"]->mem_id( $u );
			if($info["mem_id"] == $per_id)
				return "";
			$sql_query="SELECT count(ign_id)
						FROM ignores
						WHERE mem_id=".$info["mem_id"]."
						AND per_id=".$per_id;

			$exist = $GLOBALS["DB"]->single($sql_query);
			return (!$exist) ? $details[2] : $details[3];
			break;

		case 'MAILBOX':
			$sql_query="SELECT count(mes_id)
						FROM mailbox
						WHERE mem_id=".$info["mem_id"]."
						AND mailbox != 'sent'
						AND viewed='0'";

			$new_messages = $GLOBALS["DB"]->single($sql_query);
			return (!$new_messages) ? $details[2] : $details[3];
			break;

		case 'IS_PAID':
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
			if(!empty($getpaid["membership"][$info["membership"]]["price"]))
				return $details[2];
			else
				return $details[3];
			break;

		case 'LOGGED_IN':
			return ($info["mem_id"]) ? $details[2] : $details[3];
			break;

		case 'LOGGED_IN-MAILBOX':
			return ($info["mem_id"]) ? handle_special_menu_item( preg_replace("/LOGGED_IN-/", "", $code ) ) : "";
			break;
			
		case 'CHANNEL_COMMENTS':
			$u = $GLOBALS["Get"]->val("u");
			$per_id = $GLOBALS["Member"]->mem_id( $u );
			return (auth_channel_comment( $per_id )) ? $details[2] : $details[3];
			break;
			
		case 'MODULE':
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/".$details[2].".inc.php");
			return (${$details[2]}[$details[3]]) ? $details[4] : $details[5];
			break;

	}//switch

}//handle_special_menu_item

function handle_menu_patterns($item){

	$info = $GLOBALS["Member"]->info();
	
	if(hs_ereg("\|url\|",$item)){
		$item = hs_ereg_replace("\|url\|",URL,$item);
	}//if
	
	if(hs_ereg("\|username\|",$item)){
		$username = $GLOBALS["Get"]->val("u");
		if(!$username)
			$username = $GLOBALS["Member"]->username();
		$item = hs_ereg_replace("\|username\|",$username,$item);
	}//if
	
	if(hs_ereg("\|channel_link\|",$item)){
		$username = $GLOBALS["Get"]->val("u");
		if(!$username)
			$username = $GLOBALS["Member"]->username();
		$link = build_channel_link( $username );
		$item = hs_ereg_replace("\|channel_link\|",$link,$item);
	}//if
	
	if(hs_ereg("\|my_channel_link\|",$item)){
		$username = $GLOBALS["Member"]->username();
		$link = build_channel_link( $username );
		$item = hs_ereg_replace("\|my_channel_link\|",$link,$item);
	}//if

	if(hs_ereg("\|name\|",$item)){
		$name = $GLOBALS["Member"]->username();
		$item = hs_ereg_replace("\|name\|",$name,$item);
	}//if
	
	if(hs_ereg("\|new_messages_inbox\|",$item)){
		$sql_query = "SELECT COUNT(*) FROM mailbox WHERE mailbox!='sent'  AND viewed='0' AND mem_id=".$info["mem_id"];
		$messages = $GLOBALS["DB"]->single( $sql_query );
		$item = hs_ereg_replace("\|new_messages_inbox\|",$messages,$item);
	}//if
	
	if(preg_match_all("/\|mailbox:([a-z]+)\|/", $item, $matches)) {
		foreach($matches[0] as $key => $val) {
			$box = $matches[1][$key];
			$messages = extract_mailbox_messages( $box );
			if($messages){
				$replace = " (".$messages.")";
			} else {
				$replace = "";
			}
			$item = preg_replace("/".preg_quote( $matches[0][$key], "/" )."/", $replace, $item);
		}
	}

	return $item;

}//handle_menu_patterns

function handle_mail_patterns($text,$values){

	$patterns = array_keys($values);
	$patterns[] = "site_name";
	$values["site_name"] = $GLOBALS["settings"]["site_name"];
	foreach($patterns as $pat){
		if(!preg_match( "/^http:\/\//", $values[$pat] ))
			$text = hs_ereg_replace("\|".$pat."\|",$values[$pat],$text);
		else
			$text = hs_ereg_replace("\|".$pat."\|","<a href=\"".$values[$pat]."\">".htmlspecialchars($values[$pat])."</a>",$text);
	}//foreach

	return $text;

}//handle_mail_patterns

function handle_share( $from, $recipient, $subject, $body, $type, $id ) {
	if(preg_match("/^\[/", $recipient)) {
		$username  = rtrim( $recipient, "]" );
		$username  = ltrim( $username, "[" );
		$sql_query = "SELECT mem_id FROM members WHERE username=':0:'";
		$GLOBALS["DB"]->values = array( $username );
		$to = $GLOBALS["DB"]->single( $sql_query );
		if(!$to)
			return false;
		else
			handle_internal_share( $from, $to, $subject, $body, $type, $id );
	} else {
		if(!validate_email_syntax( $recipient ))
			return false;
		else {
			$sql_query = "SELECT mem_id FROM members WHERE email=':0:'";
			$GLOBALS["DB"]->values = array( $recipient );
			$to = $GLOBALS["DB"]->single( $sql_query );
			if(!$to)
				return handle_external_share( $from, $recipient, $subject, $body, $type, $id );
			else
				return handle_internal_share( $from, $to, $subject, $body, $type, $id );
		}
	}
}

function handle_external_share( $from, $to, $subject, $body, $type, $id ) {
	if($type == "channel"){
		$add["update_query"] = "UPDATE invitations SET channel='".$id."'";
		$add["share_link"] = build_channel_link( $id, 1 )."inv_id=|inv_id|";
		$mes_id = 11;
	}
	elseif($type == "video") {
		$viewkey = build_viewkey( "video", array( $id, $to ) );
		$add["update_query"] = "UPDATE invitations SET vid_id=".$id;
		$add["share_link"] = URL."/index.php?page=videos&section=view&vid_id=".$id;
		if($viewkey){$add["share_link"].= "&viewkey=".$viewkey;}
		$mes_id = 13;
	}
	elseif($type == "playlist") {
		$viewkey = build_viewkey( "playlist", array( $id, $to ) );
		$add["update_query"] = "UPDATE invitations SET pla_id=".$id;
		$add["share_link"] = URL."/index.php?page=playlists&section=view&pla_id=".$id;
		if($viewkey){$add["share_link"].= "&viewkey=".$viewkey;}
		$mes_id = 14;
	}
	return handle_external_invitation( $from, $to, $subject, $body, $mes_id, $add );
}

function handle_internal_share( $from, $to, $subject, $body, $type, $id ) {
	include_once(DOC_ROOT."/classes/Mail.class.php");
	
	if($type == "channel"){
		$mes_id = 112;
		$special = "channel|".$id;
	}
	elseif($type == "video") {
		$mes_id = 111;
		build_access( "video", array( $id, $to ) );
		$special = "video|".$id;
	}
	elseif($type == "playlist") {
		$mes_id = 113;
		build_access( "playlist", array( $id, $to ) );
		$special = "playlist|".$id;
	}

	$mail_details1 = array (
		"mes_id" => $mes_id,
		"sender" => $from,
		"member_name" => $GLOBALS["Member"]->username($from),
		"special" => $special,
		"mailbox" => "shared",
		"body" => $body
	);
	
	$GLOBALS["Mail"]->details = $mail_details1;
	$GLOBALS["Mail"]->details["recipient"] = $to;
	$GLOBALS["Mail"]->send_internal();
	
	if($type == "channel"){
		$mes_id = 10;
		$slink = build_channel_link( $id );
	}
	elseif($type == "video"){
		$mes_id = 12;
		$slink = URL."/index.php?page=videos&section=view&vid_id=".$id;
	}
	elseif($type == "playlist"){
		$mes_id = 15;
		$slink = URL."/index.php?page=playlists&section=view&pla_id=".$id;
	}

	//building email message
	$mail_details2 = array (
		"mes_id"      => $mes_id,
		"recipient"   => $to,
		"member_name" => $GLOBALS["Member"]->username($from),
		"slink"       => $slink,
		"body"        => $body
	);
	//sending email
	$GLOBALS["Mail"]->details = $mail_details2;
	$GLOBALS["Mail"]->send_mass();
	//email sent
	
	return true;
}

function handle_external_invitation($mem_id,$email,$subject,$body,$mes_id=4,$additional=array()){

	$email = trim($email);

	$sql_query = "SELECT COUNT(*) FROM invitations
				  WHERE mem_id=".$mem_id." AND TO_DAYS(FROM_UNIXTIME(`date`)) = TO_DAYS(NOW())";

	$invites_sent_today = $GLOBALS["DB"]->single($sql_query);

	if($GLOBALS["settings"]["invites_per_day"] && $invites_sent_today > $GLOBALS["settings"]["invites_per_day"])
		return array("status" => false, "details" => "invites_limit");

	if(!validate_email_syntax($email)){
		$result["status"] = false;
		$result["details"] = "syntax";
		return $result;
	}//if

	$sql_query="SELECT mem_id
				FROM members
				WHERE email=':0:'";

	$GLOBALS["DB"]->values = array ($email);
	$existing_member = $GLOBALS["DB"]->single($sql_query);

	if($existing_member){
		$result = handle_internal_invitation($mem_id,$existing_member,$subject,$body);
	}//if
	else{		

		$inv_id = md5($mem_id.$email.time());
		$invitation_link = URL."/index.php?page=join&inv_id=".$inv_id;

		//building invitation email
		$mail_details = array (
			"mes_id"    => $mes_id,
			"recipient" => $email,
			"subject"   => stripslashes(html_entity_decode($subject)),
			"body"      => stripslashes(html_entity_decode($body)),
			"link"      => $invitation_link,
			"ilink"     => $invitation_link,
			"slink"     => str_replace("|inv_id|",$inv_id,$additional["share_link"]),
			"sender_name" => $GLOBALS["Member"]->username( $info["mem_id"] ),
			"member_name" => $GLOBALS["Member"]->username( $info["mem_id"] )
		);
		
		foreach($additional as $k => $v) {
			$mail_details[$k] = $v;
		}

		if($GLOBALS["settings"]["invitation_sender"] == 'USER'){
			$mail_details["sender"] = $mem_id;
		}//if

		include_once(DOC_ROOT."/classes/Mail.class.php");

		$GLOBALS["Mail"]->details = $mail_details;
		$GLOBALS["Mail"]->send_mass();
		//invitation email sent

		//updating member invitation history
		$sql_query="INSERT INTO invitations
					(inv_id,mem_id,email,subject,message,date)
					VALUES (':0:',:1:,':2:',':3:',':4:',:5:)";

		$GLOBALS["DB"]->values = array ($inv_id,$mem_id,$email,$subject,$body,time());
		$GLOBALS["DB"]->execute($sql_query);

		//updating invitation type
		if($additional["update_query"]){
			$sql_query = $additional["update_query"]." WHERE inv_id=':0:'";
			$GLOBALS["DB"]->values = array($inv_id);
			$GLOBALS["DB"]->execute($sql_query);
		}//if

		$result["status"] = true;

	}//else

	return $result;

}//handle_external_invitation

function handle_internal_invitation($sender,$recipient,$message){

	$are_connected  = $GLOBALS["Network"]->is_trusted($sender,$recipient,1);
	$is_ignored     = $GLOBALS["Member"]->is_ignored($recipient,$sender);
	$recipient_info = $GLOBALS["Member"]->info($recipient);

	$sql_query="SELECT count(mes_id)
				FROM mailbox
				WHERE mem_id=".$recipient."
				AND per_id=".$sender."
				AND mailbox='invites'";

	$is_invited = $GLOBALS["DB"]->single($sql_query);

	if($sender == $recipient){
		$result["status"] = false;
		$result["details"] = "themselves";
	}//if
	elseif($are_connected){
		$result["status"]  = false;
		$result["details"] = "connected";
	}//if
	elseif($is_ignored){
		$result["status"]  = false;
		$result["details"] = "ignored";
	}//else
	elseif($is_invited){
		$result["status"]  = false;
		$result["details"] = "invited";
	}//elseif
	else{

		include_once(DOC_ROOT."/classes/Mail.class.php");

		$GLOBALS["Mail"]->details = array (
			"mes_id" => 106,
			"recipient" => $recipient,
			"sender" => $sender,
			"member_name" => $GLOBALS["Member"]->username( $sender ),
			"mailbox" => "invites",
			"body" => $message
		);
		$GLOBALS["Mail"]->send_internal();

		//building email message
		$mail_details = array (
			"mes_id"    => 5,
			"recipient" => $recipient
		);

		$GLOBALS["Mail"]->details = $mail_details;
		$GLOBALS["Mail"]->send_mass();
		//email sent

		$result["status"] = true;

	}//else

	return $result;

}//handle_internal_invitation

function handle_multipages($page,$total,$link,$items_per_page=0,$pagevar="p"){

	if(!$items_per_page)
		$items_per_page = 20;

	$pages["items_per_page"] = $items_per_page;

	if(empty($page)){
		$page = 0;
	}//if

	$pages["start"] = $page*$items_per_page;
	$pages["end"]   = $pages["start"] + $items_per_page;
	if($pages["end"] > $total){
		$pages["end"] = $total;
	}//if

	if($total%$items_per_page == 0){
		$total_pages = $total/$items_per_page - 1;
		if($total_pages < 0){
			$total_pages = 0;
		}//if
	}//if
	else{
		$total_pages = (int)($total/$items_per_page);
	}//else

	if($page > 0){
		if(!hs_eregi("\|$pagevar\|",$link))
		$pages["prev"] = $link."&".$pagevar."=".($page-1);
		else
		$pages["prev"] = hs_ereg_replace("\|$pagevar\|",(string)($page-1),$link);
	}//if

	if($total_pages > 0){
		if($total_pages > 15){
			$start = $page - 7;
			if($start < 0)
				$start = 0;
			$end = $start + 15;
			if($end > $total_pages){
				$end = $total_pages;
				$start = $end - 15;
			}//if
		}//if
		else{
			$start = 0;
			$end = $total_pages;
		}//else
		for($i=$start;$i<=$end;$i++){
			if(!hs_eregi("\|$pagevar\|",$link))
			$pages["numbers"][$i+1] = $link."&".$pagevar."=".$i;
			else
			$pages["numbers"][$i+1] = hs_ereg_replace("\|$pagevar\|",(string)$i,$link);
		}//for
	}//if

	if($page < $total_pages){
		if(!hs_eregi("\|$pagevar\|",$link))
		$pages["next"] = $link."&".$pagevar."=".($page+1);
		else
		$pages["next"] = hs_ereg_replace("\|$pagevar\|",(string)($page+1),$link);
	}//if
	
	if($start > 0){
		if(!hs_eregi("\|$pagevar\|",$link))
		$pages["first"] = $link."&".$pagevar."=0";
		else
		$pages["first"] = hs_ereg_replace("\|$pagevar\|","0",$link);
	}
	
	if($end < $total_pages){
		if(!hs_eregi("\|$pagevar\|",$link))
		$pages["last"] = $link."&".$pagevar."=".$total_pages;
		else
		$pages["last"] = hs_ereg_replace("\|$pagevar\|",(string)($total_pages),$link);
	}

	$pages["current"] = $page+1;

	return $pages;

}//handle_multipages

function handle_roundpages( $start, $total, $items_per_page = 4 ) {
	
	$pages = array();
	$pages["page"] = ($start) ? $start : 0;
	$pages["items_per_page"] = $items_per_page;
	$pages["next"] = -1;
	$pages["prev"] = -1;
	
	if($total <= $items_per_page)
		return $pages;
		
	//next page
	$pages["next"] = $start + $items_per_page;
	if($pages["next"] > $total) {
		$pages["next"] = $pages["next"] - $total;
	}
	
	//prev page
	$prev_item = $start - 1;
	if($prev_item < 0)
		$prev_item = $total-1;
		
	$pages["prev"] = $prev_item - $items_per_page + 1;
	if($pages["prev"] < 0) {
		$pages["prev"] = $total + $pages["prev"];
	}
	
	return $pages;
	
}

function handle_sql_patterns($str){

	$str = mysql_escape_string( $str );
	$str = hs_ereg_replace("%","\%",$str);
    $str = hs_ereg_replace("_","\_",$str);

    return $str;

}//handle_sql_patterns

function handle_non_alpha($str){

	$str = hs_ereg_replace("[^A-Za-z|^0-9|^_]","",$str);
	return $str;

}//handle_non_alpha

function handle_sql_filter($ar,$filter,$andor){

	$sql_query = "(";
	foreach($ar as $item){
		$sql_query.= $filter." LIKE ('%,".$item.",%') ".$andor." ";
	}//foreach
	$sql_query = rtrim($sql_query," ".$andor." ");
	$sql_query.= ")";

	return $sql_query;

}//handle_sql_filter

function handle_wordwrap($text){

	$text = html_entity_decode($text);
	$text = hs_ereg_replace(preg_quote("&#124;"),preg_quote("|"),$text);

	$lines = explode("\n",$text);
	for($i=0;$i<count($lines);$i++){
		$words = explode(" ",$lines[$i]);
		for($j=0;$j<count($words);$j++){
			$strlen = hs_strlen($words[$j]);
			if($strlen > 50){
				$parts = round($strlen/50);
				for($k=0;$k<=$parts;$k++){
					$subwords[] = hs_substr($words[$j],$k*50,($k+1)*50);
				}//for
				$words[$j] = implode(" ",$subwords);
			}//if
		}//for
		$lines[$i] = implode(" ",$words);
	}//for
	$text = implode("\n",$lines);

	$text = htmlentities($text);
	$text = hs_ereg_replace(preg_quote("&#124;"),preg_quote("|"),$text);

	return $text;

}//handle_wordwrap

function handle_folder_clean($folder){

	$dir = opendir($folder);
	while($file = readdir($dir)){
		if($file!="." && $file!=".." && is_file($folder."/".$file)){
			@unlink($folder."/".$file);
		}//if
	}//while
	closedir($dir);

	return true;

}//handle_folder_clean

function handle_folder_clean_total($folder){

	$dir = opendir($folder);
	while($file = readdir($dir)){
		if($file!="." && $file!=".."){
			if(is_file($folder."/".$file))
				@unlink($folder."/".$file);
			else
				handle_folder_clean_total($folder."/".$file);
		}//if
	}//while
	closedir($dir);

	rmdir($folder);

}//handle_folder_clean_total

function handle_js_patterns($javascript){

	$htmlareas = "";
	$forms = $GLOBALS["forms"];
	foreach($forms as $form){
		if(is_array($form["types"])){
			while(list($key,$val) = each($form["types"])){
				if($val == "htmlarea"){
					if(!strstr($htmlareas,"html_".$form["names"][$key]))
                        $htmlareas.= "html_".$form["names"][$key].",";
				}//if
			}//while
		}//if
	}//foreach
	$htmlareas = rtrim($htmlareas,',');

	$patterns = array (
		"::URL::"            => URL,
		"::THEME::"          => $GLOBALS["THEME"]
	);

	while(list($pattern,$replacement) = each($patterns)){
		$javascript = hs_ereg_replace($pattern,$replacement,$javascript);
	}//while

	if(preg_match_all("/::LANGUAGE:[^:]+/",$javascript,$matches)){
		foreach($matches as $submatch){
			foreach($submatch as $match){
			$word = substr($match,11);
			$javascript = hs_ereg_replace($match."::",$GLOBALS["language"][$word],$javascript);
			}//foreach
		}//foreach
	}//if

	return $javascript;

}//handle_js_patterns

function handle_connection_close(){

	$GLOBALS["DB"]->disconnect();

}//handle_connection_close

function handle_avatar_resize( $tmpfile, $extension, $upload = 1 ) {

	$path = DOC_ROOT."/avt";

	$image = build_unique_path( $path, $extension ).$extension;

	if($upload)
	move_uploaded_file($tmpfile,DOC_ROOT."/avt/".$image);
	else
	rename($tmpfile,DOC_ROOT."/avt/".$image);

	chmod(DOC_ROOT."/avt/".$image,0644);

	$width  = $GLOBALS["settings"]["avatar"]["width"];
	$height = $GLOBALS["settings"]["avatar"]["height"];

	handle_image_resize( DOC_ROOT."/avt/".$image, $width, $height, $extension, 1 );

	return $image;

}

function handle_image_resize( $file, $width, $height, $extension, $ratio = 0, $blackbcg = 0 ) {

	list($ex_width,$ex_height) = getimagesize( $file );

	if($ex_width > $width || $ex_height > $height):
	
	if($ratio) {
		
		$width_diff = $ex_width - $width;
		$height_diff = $ex_height - $height;

		if($width_diff >= $height_diff){
	
			$ds_width  = $width;
			$ratio     = $ex_width / $ds_width;
			$ds_height = $ex_height / $ratio;
			$ds_height = round($ds_height);
	
		} else {
	
			$ds_height = $height;
			$ratio     = $ex_height / $ds_height;
			$ds_width  = $ex_width / $ratio;
			$ds_width  = round($ds_width);
	
		}
	} else {
		$ds_width  = $width;
		$ds_height = $height;
	}
	
	if($extension == ".gif"){
		$src = ImageCreateFromGif($file);
	}//if
	elseif($extension == ".jpeg"){
		$src = ImageCreateFromJpeg($file);
	}//elseif

	if(!$blackbcg) {
		$dst = ImageCreateTrueColor($ds_width,$ds_height);
		$x = 0;
		$y = 0;
	} else {
		$dst = ImageCreateTrueColor($width,$height);
		$x = round( ( $width - $ds_width ) / 2 );
		$y = round( ( $height - $ds_height ) / 2 );
	}

	ImageCopyResampled($dst,$src,$x,$y,0,0,$ds_width,$ds_height,$ex_width,$ex_height);

	if($extension == ".gif"){
		ImageGif($dst,$file);
	}//if
	elseif($extension == ".jpeg"){
		ImageJpeg($dst,$file,80);
	}//elseif

	ImageDestroy($src);
	ImageDestroy($dst);

	endif;

}

function handle_xml_entities($xml,$reverse=FALSE){

    static $literal2NumericEntity;

    if (empty($literal2NumericEntity)) {
      $transTbl = get_html_translation_table(HTML_ENTITIES);
      foreach ($transTbl as $char => $entity) {
        if (strpos('&"<>', $char) !== FALSE) continue;
        $literal2NumericEntity[$entity] = '&#'.ord($char).';';
      }//foreach
    }//if
    if ($reverse) {
      return strtr($xml, array_flip($literal2NumericEntity));
    } else {
      return strtr($xml, $literal2NumericEntity);
    }

}//handle_xml_entities

function handle_session_data($values,$mem_id,$session=0){

	if(!$mem_id)
		return false;

	if(!$session){
		$sql_query = "DELETE FROM sessiondata WHERE saved < ".(time() - 3600*24);
		$GLOBALS["DB"]->execute($sql_query);
		$data = urlencode(serialize($values));
		$sql_query = "INSERT INTO sessiondata (mem_id,data,saved) VALUES (:mem_id:,':data:',:time:)";
		$GLOBALS["DB"]->values = array("mem_id" => $mem_id, "data" => $data, "time" => time());
		$session = $GLOBALS["DB"]->insert($sql_query);
	}//if
	else{
		$vals = extract_session_data($session,$mem_id);
		foreach($values as $key => $val){
			$vals[$key] = $val;
		}//foreach
		$data = urlencode(serialize($vals));
		$sql_query = "UPDATE sessiondata SET data=':data:',saved=:time: WHERE id=:id: AND mem_id=:mem_id:";
		$GLOBALS["DB"]->values = array ("data" => $data, "saved" => time(), "id" => $session, "mem_id" => $mem_id, "time" => time());
		$GLOBALS["DB"]->execute($sql_query);
	}//else

	return $session;

}//handle_session_data

function handle_system_messages_patterns( $message ) {

	preg_match_all( "/;setting;([0-9|A-Z|a-z|_]+);/", $message, $matches );
	foreach( $matches[0] as $key => $match ) {
		$setting = $matches[1][$key];
		$message = preg_replace( "/".preg_quote( $match, "/" )."/", $GLOBALS["settings"][$setting], $message );
	}

	$matches = array();
	reset($matches);
	preg_match_all( "/;module;([0-9|A-Z|a-z|_]+);([0-9|A-Z|a-z|_]+);/", $message, $matches );
	foreach( $matches[0] as $key => $match ) {
		$module  = $matches[1][$key];
		$setting = $matches[2][$key];
		include( DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/".$module.".inc.php");
		$data = ${$module}[$setting];
		$message = preg_replace( "/".preg_quote( $match, "/" )."/", $data, $message );
	}

	return $message;
}

function handle_string_cut( $text, $limit = 200 ){
	if( hs_strlen( $text ) > $limit )
		return hs_substr( $text, 0, $limit )."...";
	else
		return $text;
}

function handle_num_format( $number ) {
	return number_format( $number, 0, null, "," );
}

function handle_video_convert( $hash, $ext, $vid_id, $disk_space = 0 ) {
	
	include_once(DOC_ROOT."/functions/converter/".CONVERTER.".php");
	
	if(!file_exists( DOC_ROOT."/vid/".$hash.$ext ))
		return array( false, 57 );
	
	$vals = array();
	$vals["converted"] = 1;
	$flv_video_name = $hash.".flv";
	
	converter_convert( DOC_ROOT."/vid/".$hash.$ext, DOC_ROOT."/vid/".$flv_video_name, $ext );
	
	if(!file_exists( DOC_ROOT."/vid/".$flv_video_name ))
		return array( false, 57 );
	
	$vals["length"] = (converter_data( DOC_ROOT."/vid/".$flv_video_name, "duration" ));

	if($ext != ".flv")
		@unlink(DOC_ROOT."/vid/".$hash.$ext);
	
	$disk_space+= filesize( DOC_ROOT."/vid/".$flv_video_name );
	if( $GLOBALS["Videos"]->diskspace > 0 && $disk_space > $GLOBALS["Videos"]->diskspace * 1048576 ) {
		return array( false, 58 );
	}
	
	if( $GLOBALS["Videos"]->maxtime > 0 && $vals["length"] > $GLOBALS["Videos"]->maxtime * 60 ) {
		return array( false, 59 );
	}
	
	$shash = build_unique_path( DOC_ROOT."/scr", ".jpg" );

	if( build_screenshot(DOC_ROOT."/vid/".$flv_video_name, $shash, $vals["length"]) ){
		$vals["screenshot"] = 1;
		$vals["shash"] = $shash;
	}
	else{
		$vals["screenshot"] = 0;
		$vals["shash"] = "";
	}
		
	$sql_query = "UPDATE videos SET converted=':converted:',length=':length:',screenshot=:screenshot:,shash=':shash:'
				  WHERE vid_id=".$vid_id;
	$GLOBALS["DB"]->values = $vals;
	$GLOBALS["DB"]->execute( $sql_query );
	
	return array( true );
	
}

?>
