<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("act");
						$section = $GLOBALS["Get"]->val("section");

							switch($section){

								case 'share':
									video_share_view();
									break;
									
								case 'bookmark':
									video_bookmark_view();
									break;
								
								case 'flag':
									video_flag_view();
									break;
									
								case 'playlists':
									video_playlists_view();
									break;
									
								case 'responses':
									video_responses_view();
									break;
									
								case 'comments':
									video_comments_view();
									break;
									
								case 'subcomments':
									video_subcomments_view();
									break;
									
								case 'videos':
									video_list_view();
									break;
									
								case 'watched':
									videos_being_watched();
									break;
									
								case 'thumbnails':
									video_thumbnails();
									break;

							}//switch
							
							switch($action){

								case 'share':
									video_share_process();
									break;
									
								case 'bookmark':
									video_bookmark_process();
									break;
									
								case 'flag':
									video_flag_process();
									break;
									
								case 'playlists':
									video_playlists_process();
									break;
									
								case 'rating':
									video_rating_process();
									break;
									
								case 'comment':
									video_comment_process();
									break;
									
								case 'comment_rate':
									video_comment_rate_process();
									break;
									
								case 'delete_response':
									video_delete_response_process();
									break;

							}//switch

						///////////////////////////////////////
						
function video_share_view() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	build_form( "share" );
	
	$GLOBALS["smarty"]->assign( "forms", $GLOBALS["forms"] );
	$GLOBALS["smarty"]->assign( "form", "share" );
	echo "<div style='text-align:left'>";
	$GLOBALS["smarty"]->display( "forms/onecol.tpl" );
	echo "</div>";
	exit;
}

function video_bookmark_view() {
	
	global $language;
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$exists = $GLOBALS["Videos"]->is_bookmarked($vid_id);
	
	$button = array();
	$button["name"] = ($exists) ? $language["remove_video_from_my_favorites"] : $language["add_video_to_my_favorites"];
	$button["link"] = "CH_AjaxRequest( 'ajax.php?module=videos&act=bookmark&vid_id=".$vid_id."', 'videoOptionsHandler')";
	$GLOBALS["smarty"]->assign( "button", $button );
	$GLOBALS["smarty"]->display( "forms/bookmark.tpl" );
	exit;
}

function video_flag_view() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	build_form( "flag" );
	
	$GLOBALS["smarty"]->assign( "forms", $GLOBALS["forms"] );
	$GLOBALS["smarty"]->assign( "form", "flag" );
	$GLOBALS["smarty"]->display( "forms/onecol.tpl" );
	exit;
}

function video_playlists_view() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	build_form( "playlists" );
	
	$GLOBALS["smarty"]->assign( "forms", $GLOBALS["forms"] );
	$GLOBALS["smarty"]->assign( "form", "playlists" );
	$GLOBALS["smarty"]->display( "forms/onecol.tpl" );
	exit;
}

function video_responses_view() {
	
	$info = $GLOBALS["Member"]->info();
	
	$start  = $GLOBALS["Get"]->type_val("s","integer");
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$total  = $GLOBALS["Videos"]->responses( $vid_id );
	
	$video["vid_id"] = $vid_id;
	
	$sql_query = "SELECT * FROM videos WHERE vid_id=".$vid_id;
	$entry = $GLOBALS["DB"]->row( $sql_query );
	
	$sql_query = "SELECT v.vid_id FROM video_responses AS vr,videos AS v WHERE v.vid_id=vr.vid_id
				  AND vr.approved='1' AND vr.response_to=".$vid_id." ".$GLOBALS["Videos"]->filter("v.")." ORDER BY vr.posted DESC LIMIT ".$start.",4";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$responses = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$responses[] = $card;
	}
	
	if(count( $responses ) < 4 && $start > 0) {
		$missing = 4 - count( $responses );
		$sql_query = "SELECT v.vid_id, v.mem_id FROM video_responses AS vr,videos AS v WHERE v.vid_id=vr.vid_id
					  AND vr.approved='1' AND vr.response_to=".$vid_id." ".$GLOBALS["Videos"]->filter("v.")." ORDER BY vr.posted DESC LIMIT 0,".$missing;
		$result = $GLOBALS["DB"]->result( $sql_query );
		foreach($result as $res) {
			$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
			if($res["mem_id"] == $info["mem_id"] || $info["mem_id"] == $entry["mem_id"])
				$card["delete"] = 1;
			$responses[] = $card;
		}
	}
	
	$responses_pages = handle_roundpages( $start, $total );
	
	$GLOBALS["smarty"]->assign("video", $video);
	$GLOBALS["smarty"]->assign("masterVideo", $video);
	$GLOBALS["smarty"]->assign("responses", $responses);
	$GLOBALS["smarty"]->assign("responses_pages", $responses_pages);	
	$GLOBALS["smarty"]->display( "boxes/video_responses_content.tpl" );
	exit;
	
}

function video_comment_form_view() {
	
	build_form( "comment" );
	
	$GLOBALS["smarty"]->assign( "forms", $GLOBALS["forms"] );
	$GLOBALS["smarty"]->assign( "form", "comment" );
	$GLOBALS["smarty"]->display( "forms/onecol.tpl" );
	exit;
	
}

function video_comments_view() {
	
	$info = $GLOBALS["Member"]->info();
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id", "integer");
	$p      = $GLOBALS["Get"]->type_val("p", "integer");
	
	$sql_query = "SELECT COUNT(*) FROM video_comments WHERE vid_id=".$vid_id." AND reply_to = 0 AND approved='1'";
	$total = $GLOBALS["DB"]->single( $sql_query );
	$pages = handle_multipages( $p, $total, "CH_AjaxRequest( 'ajax.php?module=videos&section=comments&vid_id=".$vid_id."&p=|p|', 'videoCommentsBody', 'no' )", 5 );
	$sql_query = "SELECT * FROM video_comments WHERE vid_id=".$vid_id." AND reply_to = 0 AND approved='1'
				  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	$comments = array();
	
	$entry = $GLOBALS["Videos"]->info( $vid_id );
	
	foreach($result as $res) {
		
		$comment = array();
		$comment["comment"] = nl2br( $res["comment"] );
		$comment["com_id"]  = $res["com_id"];
		$comment["from"]    = $GLOBALS["Member"]->card( $res["mem_id"] );
		$comment["posted"]  = extract_time_relative( $res["posted"] );
		$comment["rating"]  = $res["rating"];
		$comment["owner"]   = ($info["mem_id"] == $res["mem_id"]) ? true : false;
		if($res["mem_id"] == $info["mem_id"] || $entry["mem_id"] == $info["mem_id"])
			$comment["delete"] = 1;
		
		$sql_query = "SELECT COUNT(*) FROM video_comments WHERE reply_to=".$res["com_id"]." AND approved='1'";
		$comment["replies"] = $GLOBALS["DB"]->single($sql_query);
		$comments[] = $comment;
	}
	
	$settings = array();
	$settings["comments"]       = $entry["comments"];
	$settings["comment_voting"] = $entry["comment_voting"];
	$settings["responses"]      = $entry["responses"];
	$settings["ratings"]        = $entry["ratings"];
	$settings["embedding"]      = $entry["embedding"];
	
	$GLOBALS["smarty"]->assign("vsettings", $settings);
	$GLOBALS["smarty"]->assign("comments", $comments);
	$GLOBALS["smarty"]->assign("comments_pages", $pages);
	$GLOBALS["smarty"]->display( "lists/comments.tpl" );
	exit;
}

function video_subcomments_view() {
	
	$info = $GLOBALS["Member"]->info();
	
	$com_id = $GLOBALS["Get"]->type_val("com_id", "integer");
	
	$sql_query = "SELECT * FROM video_comments WHERE reply_to = ".$com_id." AND approved='1'
				  ORDER BY posted DESC";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$vid_id = $result[0]["vid_id"];
	
	if($vid_id){
	$sql_query = "SELECT mem_id FROM videos WHERE vid_id=".$vid_id;
	$video = $GLOBALS["DB"]->row( $sql_query );
	}
	
	$comments = array();
	foreach($result as $res) {
		$comment = array();
		
		$comment["comment"] = nl2br( $res["comment"] );
		$comment["com_id"]  = $res["com_id"];
		$comment["from"]    = $GLOBALS["Member"]->card( $res["mem_id"] );
		$comment["posted"]  = extract_time_relative( $res["posted"] );
		$comment["owner"]   = ($info["mem_id"] == $res["mem_id"]) ? true : false;
		if($res["mem_id"] == $info["mem_id"] || $video["mem_id"] == $info["mem_id"])
			$comment["delete"] = 1;
		
		$comments[] = $comment;
	}
	
	$GLOBALS["smarty"]->assign("com_id", $com_id);
	$GLOBALS["smarty"]->assign("subcomments", $comments);
	$GLOBALS["smarty"]->display( "boxes/video_subcomments.tpl" );
	exit;
	
}

function video_list_view() {
	
	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$info["mem_id"];
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");
	$ajax_link = "CH_AjaxRequest( 'ajax.php?module=videos&section=videos&p=|p|', 'videosList', 'no' )";
	$ajax_pages = handle_multipages($p,$total,$ajax_link);

	$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$info["mem_id"]." AND converted='1'
				  ORDER BY posted DESC LIMIT ".$ajax_pages["start"].",".$ajax_pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$videos[] = $GLOBALS["Videos"]->card($res["vid_id"]);
	}//foreach

	$GLOBALS["smarty"]->assign("videos",$videos);
	$GLOBALS["smarty"]->assign("pages",$ajax_pages);
	
	$GLOBALS["smarty"]->display( "boxes/videos_list.tpl" );
	exit;
	
}

function videos_being_watched() {
	
	$sql_query = "SELECT COUNT(DISTINCT vw.vid_id) FROM video_watch AS vw, videos AS v WHERE v.vid_id = vw.vid_id
				  ".$GLOBALS["Videos"]->filter("v.")." GROUP BY vw.vid_id";
	$total = $GLOBALS["DB"]->single( $sql_query );
	if($total > 50) {	
		$limit = $total - 50;
		$sql_query = "DELETE FROM video_watch WHERE expire > ".time()." LIMIT ".$limit;
		$GLOBALS["DB"]->execute( $sql_query );
	}
	
	$sql_query = "SELECT DISTINCT vw.vid_id FROM video_watch AS vw, videos AS v WHERE v.vid_id = vw.vid_id
				  ".$GLOBALS["Videos"]->filter("v.")." GROUP BY vw.vid_id ORDER BY RAND() LIMIT 0,50";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$reply = "<videos>\n";
	foreach($result as $res) {
		$video = $GLOBALS["DB"]->row( "SELECT title, length, shash, screenshot FROM videos WHERE vid_id=".$res["vid_id"] );
		$video["shash"] = $GLOBALS["Videos"]->screenshot( $res["vid_id"] );
		$reply.= "<video>";
		$reply.= "<vid_id>".htmlspecialchars( $res["vid_id"] )."</vid_id>";
		$reply.= "<title>".htmlspecialchars( $video["title"] )."</title>";
		$reply.= "<duration>".htmlspecialchars( extract_duration( $video["length"] ) )."</duration>";
		$reply.= "<shash>".htmlspecialchars( $video["shash"] )."</shash>";
		$reply.= "</video>\n";
	}
	$reply.= "</videos>";
	
	$encoding = extract_encoding("html");
	Header("Content-Type:text/xml; charset=".$encoding);
	echo $reply;
	exit;
	
}

function video_thumbnails() {
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$data   = $GLOBALS["DB"]->row( "SELECT * FROM videos WHERE vid_id = ".$vid_id );
	
	$reply = "<thumbnails>";
	
	if($data["source"] != "embed") {
	
		$reply.= "<default>".$data["shash"]."_".$data["screenshot"]."</default>";
		for($i = 1; $i <= $GLOBALS["Videos"]->screenshots; $i++) {
			if( file_exists( DOC_ROOT."/scr/".$data["shash"]."_".$i.".jpg" ) ) {
				$reply.= "<image>".$data["shash"]."_".$i."</image>";
			}
		}
		
	} else {
		
		include_once( DOC_ROOT."/modules/grabber/".$data["service"].".php" );
		$thumbs = g_thumbnails( $data["vhash"] );
		$reply.= "<default>".htmlspecialchars( $thumbs[$data["screenshot"]] )."</default>";
		foreach($thumbs as $th) {
			$reply.= "<image>".htmlspecialchars( $th )."</image>";
		}
		
	}
	
	$reply.= "</thumbnails>";
	
	$encoding = extract_encoding("html");
	Header("Content-Type:text/xml; charset=".$encoding);
	print "<?xml version=\"1.0\" encoding=\"".$encoding."\"?>\n";
	print $reply;	
	exit;
	
}

function video_share_process() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	if(!auth_video_access_ajax()){
		build_error(43, null, null, 1);
		exit;
	}
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("share");
	$values["to"] = handle_empties(explode(",",$values["to"]));
	
	if(count($values["to"]) == 0) {
		build_error(15,null,null,1);
		video_share_view();
		exit;
	}

	foreach($values["to"] as $contact) {
		$contact = trim($contact);
		handle_share( $info["mem_id"], $contact, $values["subject"], $values["message"], "video", $values["vid_id"] );
	}
	echo "js:CH1";
	build_complete( 18, 1 );
	exit;
	
}

function video_bookmark_process() {
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	if(!auth_video_access_ajax()){
		build_error(43, null, null, 1);
		exit;
	}
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");

	$exists = $GLOBALS["Videos"]->is_bookmarked($vid_id);

	if($exists){
		$sql_query = "DELETE FROM bookmarks WHERE mem_id=".$info["mem_id"]."
					  AND item_id=".$vid_id;

		$GLOBALS["DB"]->execute($sql_query);
		$cmp_id = 20;
	}//if
	else{
		$sql_query = "INSERT INTO bookmarks (mem_id,item_id,added)
					  VALUES (".$info["mem_id"].",".$vid_id.",".time().")";

		$GLOBALS["DB"]->execute($sql_query);
		
		$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date) VALUES (".$info["mem_id"].",".$vid_id.",5,".time().")";
		$GLOBALS["DB"]->execute( $sql_query );
		
		$cmp_id = 19;
	}//else
	echo "js:CH1";
	build_complete( $cmp_id, 1 );
	exit;
}

function video_flag_process() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	if(!auth_video_access_ajax()){
		build_error(43, null, null, 1);
		exit;
	}
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("flag");
	
	$types[1] = "spam";
	$types[2] = "mature";
	$types[3] = "mis-categorized";
	$types[4] = "copyright";
	
	$type = $types[$values["reason"]];
	
	if($values["vid_id"] && $type) {
	
		$sql_query = "INSERT INTO reports( mem_id, report, date, special)
					  VALUES (:mem_id:,':report:',:time:,:vid_id:)";
		$GLOBALS["DB"]->values = array (
			"mem_id" => $info["mem_id"],
			"report" => $type,
			"time" => time(),
			"vid_id" => $values["vid_id"]
		);
		$GLOBALS["DB"]->execute( $sql_query );
	
	}
	
	echo "js:CH1";
	build_complete( 33, 1 );
	exit;
	
}

function video_playlists_process() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	if(!auth_video_access_ajax()){
		build_error(43, null, null, 1);
		exit;
	}
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("playlists");
	
	if(!$values["pla_id"]){
		build_error( 42, null, null, 1 );
		exit;
	} elseif($values["pla_id"] == "new") {
		echo "js:CH2:".$values["vid_id"];
		exit;
	} else {
		if(!auth_playlist_edit_access( 1 )){
			build_error( 43, null, null, 1 );
			exit;
		} else {
			$GLOBALS["Videos"]->add_to_playlist( $values["vid_id"], $values["pla_id"] );
		}
	}
	
	echo "js:CH1";
	build_complete( 21, 1 );
	exit;
	
}

function video_rating_process() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(44, null, null, 1);
		exit;
	}
	
	if(!auth_video_access_ajax()){
		build_error(43, null, null, 1);
		exit;
	}
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$rate = $GLOBALS["Get"]->type_val("rate","integer");
	
	if(!$vid_id || !$rate)
		exit;
		
	$video = $GLOBALS["Videos"]->info( $vid_id );
	if($video["ratings"] == 2)
		exit;
	
	$exists = $GLOBALS["Videos"]->rated( $info["mem_id"], $vid_id );
	
	if($exists) {
		echo $GLOBALS["language"]["already_rated"];
		exit;
	} else {
		$sql_query = "UPDATE videos SET rating=rating+:rate:, votes=votes+1 WHERE vid_id=".$vid_id;
		$GLOBALS["DB"]->values = array("rate" => $rate);
		$GLOBALS["DB"]->execute($sql_query);
		$sql_query = "SELECT timestamp FROM video_votes WHERE vid_id = ".$vid_id." ORDER BY timestamp DESC LIMIT 100,1";
		$timestamp = $GLOBALS["DB"]->single( $sql_query );
		if($timestamp) {
			$sql_query = "DELETE FROM video_votes WHERE timestamp <= ".$timestamp;
			$GLOBALS["DB"]->execute( $sql_query );
		}
		$sql_query = "REPLACE INTO video_votes (mem_id, vid_id, timestamp, rate)
					  VALUES (:mem_id:,:vid_id:,:time:,:rate:)";
		$GLOBALS["DB"]->values = array (
			"mem_id" => $info["mem_id"],
			"vid_id" => $vid_id,
			"time"   => time(),
			"rate"   => $rate
		);
		$GLOBALS["DB"]->execute( $sql_query );
		
		$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date,details) VALUES (".$info["mem_id"].",".$vid_id.",2,".time().",'".$rate."')";
		$GLOBALS["DB"]->execute( $sql_query );
		
		echo "js:CH3";
		echo $GLOBALS["language"]["thanks_for_your_rating"];
		exit;
	}
	
}

function video_comment_process() {
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	if(!auth_video_access_ajax()){
		build_error(43, null, null, 1);
		exit;
	}
	
	$vid_id  = $GLOBALS["Get"]->type_val("vid_id", "integer");
	$com_id  = $GLOBALS["Get"]->type_val("com_id", "integer");
	$comment = $GLOBALS["Get"]->val("comment");
	
	if(!$vid_id)
		exit;
		
	if(!$comment){
		build_error(0, null, null, 1);
		video_comment_form_view();
		exit;
	}
	
	if(!$com_id)
		$com_id = 0;
		
	$video = $GLOBALS["Videos"]->info( $vid_id );
	switch($video["comments"]) {
		case '4':
			exit;
			break;
		case '3':
			$approved = 0;
			break;
		case '2':
			$approved = ($GLOBALS["Network"]->is_trusted( $video["mem_id"], $info["mem_id"], 1)) ? 1 : 0;
			break;
		case '1':
			$approved = 1;
			break;
	}
	
	$sql_query = "INSERT INTO video_comments (vid_id,mem_id,comment,reply_to,posted,rating,approved)
				  VALUES (:vid_id:,:mem_id:,':comment:',:com_id:,:time:,0,':approved:')";
	$GLOBALS["DB"]->values = array (
		"vid_id"   => $vid_id,
		"mem_id"   => $info["mem_id"],
		"comment"  => $comment,
		"com_id"   => $com_id,
		"time"     => time(),
		"approved" => $approved
	);
	$newid = $GLOBALS["DB"]->insert( $sql_query );
	
	if(!$approved) {
		include(DOC_ROOT."/classes/Mail.class.php");
		$GLOBALS["Mail"]->details = array (
			"sender" => $info["mem_id"],
			"mailbox" => "comments",
			"special" => $newid,
			"recipient" => $video["mem_id"]
		);
		$GLOBALS["Mail"]->send_internal();
	} else {
		$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date) VALUES (".$info["mem_id"].",".$vid_id.",3,".time().")";
		$GLOBALS["DB"]->execute( $sql_query );
	}
	
	build_complete(22, 1);
	exit;
	
}

function video_comment_rate_process() {
	
	$info = auth_member_ajax();
	if(!$info) {
		exit;
	}	
	
	$com_id  = $GLOBALS["Get"]->type_val("com_id", "integer");	
	
	$sql_query = "SELECT vid_id,rating FROM video_comments WHERE com_id=".$com_id;
	$result = $GLOBALS["DB"]->row( $sql_query );
	$vid_id = $result["vid_id"];
	$rating = $result["rating"];
	
	$video = $GLOBALS["Videos"]->info( $vid_id );
	if($video["comment_voting"] == 2)
		exit;
	
	$sql_query = "SELECT COUNT(*) FROM video_comment_votes WHERE com_id=".$com_id." AND mem_id=".$info["mem_id"];
	$exists = $GLOBALS["DB"]->single( $sql_query );
	
	if(auth_video_access_ajax($vid_id) && !$exists){
	
		$rate = $GLOBALS["Get"]->val("rate");	
		
		if($rate == "down") {
			$update = "-1";
			$rating--;
		} elseif( $rate == "up" ) {
			$update = "+1";
			$rating++;
		}
		
		$sql_query = "UPDATE video_comments SET rating=rating".$update." WHERE com_id=".$com_id;
		$GLOBALS["DB"]->execute($sql_query);
		
		$sql_query = "INSERT INTO video_comment_votes (com_id,mem_id,timestamp)
					  VALUES (".$com_id.",".$info["mem_id"].",".time().")";
		$GLOBALS["DB"]->execute($sql_query);
		
	}
	
	$GLOBALS["smarty"]->assign("rating", $rating);
	$GLOBALS["smarty"]->display( "items/comment_rating.tpl" );
	exit;			
	
}

function video_delete_response_process() {
	
	$info = auth_member_ajax();
	if(!$info) {
		exit;
	}	
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id", "integer");
	$response_id = $GLOBALS["Get"]->type_val("response_id", "integer");
	
	$sql_query = "SELECT * FROM videos WHERE vid_id=".$vid_id;
	$video = $GLOBALS["DB"]->row( $sql_query );
	
	$sql_query = "SELECT * FROM videos WHERE vid_id=".$response_id;
	$response = $GLOBALS["DB"]->row( $sql_query );
	
	if($video["mem_id"] == $info["mem_id"] || $info["mem_id"] == $response["mem_id"]) {
		$sql_query = "DELETE FROM video_responses WHERE vid_id=".$response_id." AND response_to=".$vid_id;
		$GLOBALS["DB"]->execute( $sql_query );
	}
	
	video_responses_view();
	
}

?>