<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function extract_option($name,$option){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/options/".$name.".inc.php");
	$ret = $options[$option];
	return $ret;

}//extract_option

function extract_switch($name,$option){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/options/".$name.".inc.php");
	$ret = $options[$option];
	return $ret;

}//extract_switch

function extract_set($name,$value){

	$ret = "";
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/options/".$name.".inc.php");
	$vals = explode("|",$value);
	$vals = handle_empties($vals);

	foreach($vals as $val){
		$ret.= $options[$val].", ";
	}//foreach
	$ret = rtrim($ret,", ");

	return $ret;

}//extract_set

function extract_txt_set($options){

	$ret = "";
	$vals = explode("|",$options);
	$vals = handle_empties($vals);

	foreach($vals as $val){
		$ret.= $val.", ";
	}//foreach
	$ret = rtrim($ret,", ");

	return $ret;

}//extract_txt_set

function extract_age($birthdate){

	if($birthdate!=0){
		include_once(DOC_ROOT."/functions/adodb-time.php");
		$diff = time() - $birthdate;
		$ret = adodb_date("Y",$diff) - 1970;
		return $ret;
	}//if
	else
	return "";

}//extract_age

function extract_member_location($mem_id,$show=0){

	$member_settings = $GLOBALS["Member"]->settings($mem_id);
	if($member_settings["hide_location"] && !$show){
		return '';
	}//if
	else{
		$sql_query = "SELECT country,city,zip
					  FROM profiles WHERE mem_id=".$mem_id;
		$values = $GLOBALS["DB"]->row($sql_query);

		$place[] = extract_country($values["country"]);
		$place[] = $values["city"];
		$place[] = $values["zip"];
		$place = handle_empties($place);
		$location = implode(", ",$place);
		return $location;
	}//else

}//extract_member_location

function extract_location($country,$city){

	$place[] = extract_country($country);
	$place[] = $city;
	$place = handle_empties($place);
	$location = implode(", ",$place);
	return $location;

}//extract_location

function extract_country($con_id){

	if($con_id){
		$sql_query = "SELECT name FROM geo_countries
					  WHERE con_id=".$con_id;

		$country = $GLOBALS["DB"]->single($sql_query);
	}//if

	return $country;

}//extract_country

function extract_member_gender($mem_id,$gender,$show=0){

	$member_settings = $GLOBALS["Member"]->settings($mem_id);
	if($member_settings["hide_gender"] && !$show){
		return '';
	}//if
	else{
		return extract_switch("gender",$gender);
	}//else

}//extract_member_gender

function extract_member_age($mem_id,$birthdate,$show=0){

	$member_settings = $GLOBALS["Member"]->settings($mem_id);
	if($member_settings["hide_age"] && !$show){
		return '';
	}//if
	else{
		return extract_age($birthdate);
	}//else

}//extract_member_age

function extract_invitation_status($status){

	switch($status){

		case 'p':
			return $GLOBALS["language"]["Pending"];
			break;

		case 'j':
			return $GLOBALS["language"]["User joined the site"];
			break;

		case 'f':
			return $GLOBALS["language"]["User is your friend now."];
			break;

	}//switch

}//extract_invitation_status

function extract_page_menus($page){

	$applied_menus = array ();

	$sql_query = "SELECT association FROM associations WHERE assoc_type='menu' AND page='".$page."' AND theme='".$GLOBALS["THEME"]."'";
	$result = $GLOBALS["DB"]->result($sql_query);

	foreach($result as $res){
		$applied_menus[] = $res["association"];
	}//while

	return $applied_menus;

}//extract_page_menus

function extract_page_auth($page){

	$applied_auth = array ();

	$sql_query = "SELECT association FROM associations WHERE assoc_type='auth' AND page='".$page."' AND theme='".$GLOBALS["THEME"]."'";
	$result = $GLOBALS["DB"]->result($sql_query);

	foreach($result as $res){
		$applied_auth[] = $res["association"];
	}//foreach

	return $applied_auth;

}//extract_page_auth

function extract_page_forms($page){

	$applied_forms = array ();

	$sql_query = "SELECT association FROM associations WHERE assoc_type='form' AND page='".$page."' AND theme='".$GLOBALS["THEME"]."'";
	$result = $GLOBALS["DB"]->result($sql_query);

	foreach($result as $res){
		$applied_forms[] = $res["association"];
	}//foreach

	return $applied_forms;

}//extract_page_forms

function extract_page_modules($page){

	$applied_tasks = array ();

	$sql_query = "SELECT association FROM associations WHERE assoc_type='task' AND page='".$page."' AND theme='".$GLOBALS["THEME"]."'";
	$result = $GLOBALS["DB"]->result($sql_query);

	foreach($result as $res){
		$applied_tasks[] = $res["association"];
	}//while

	return $applied_tasks;

}//extract_page_tasks

function extract_null_value($value){

	if(!empty($value))
		return false;

	$value.= "test";
	if(hs_ereg("^0",$value)){
		return false;
	}//if
	else
		return true;

}//extract_null_value

function extract_membership_name($membership){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	if($getpaid["enabled"]){
		return $getpaid["membership"][$membership]["name"];
	}//if
	else
		return "";

}//extract_membership_name

function extract_date($timestamp){

	if($timestamp){
		include_once(DOC_ROOT."/functions/adodb-time.php");
		return adodb_date($GLOBALS["settings"]["date_format"],$timestamp);
	}//if
	else
		return "";

}//extract_date

function extract_time($timestamp,$and_date=1){

	if($timestamp){

		include_once(DOC_ROOT."/functions/adodb-time.php");

		if($and_date)
			return adodb_date($GLOBALS["settings"]["date_format"],$timestamp)." ".adodb_date($GLOBALS["settings"]["time_format"],$timestamp);
		else
			return adodb_date($GLOBALS["settings"]["time_format"],$timestamp);

	}//if
	else
		return "";

}//extract_time

function extract_duration( $time ) {
	$minutes = (int)($time / 60);
	$seconds = $time % 60;
	
	if($minutes < 10)
		$minutes = "0".$minutes;
		
	if($seconds < 10)
		$seconds = "0".$seconds;
		
	return $minutes.":".$seconds;
}

function extract_time_relative($timestamp){

	$time = time() - $timestamp;

	if($time < 60){
		$passed = $time;
		if($passed == 1)
			$word = $GLOBALS["language"]["second"];
		else
			$word = $GLOBALS["language"]["seconds"];
	}//if
	elseif($time < 3600){
		$passed = round($time/60);
		if($passed == 1)
			$word = $GLOBALS["language"]["minute"];
		else
			$word = $GLOBALS["language"]["minutes"];
	}//elseif
	elseif($time < 3600*24){
		$passed = round($time/3600);
		if($passed == 1)
			$word = $GLOBALS["language"]["hour"];
		else
			$word = $GLOBALS["language"]["hours"];
	}//elseif
	else{
		$passed = round($time/(3600*24));
		if($passed == 1)
			$word = $GLOBALS["language"]["day"];
		else
			$word = $GLOBALS["language"]["days"];
	}//else

	return preg_replace("/:time:/",$passed." ".strtolower($word),$GLOBALS["language"][":time: ago"]);

}

function extract_banner_output($ban_id,$track=1){

	$sql_query = "SELECT * FROM banners WHERE ban_id=".$ban_id;
	$GLOBALS["DB"]->clean();
	$banner = $GLOBALS["DB"]->row($sql_query);

	$banner["tag"] = stripslashes(html_entity_decode($banner["tag"]));
	$banner["tag"] = hs_ereg_replace(preg_quote("&#124;"),"|",$banner["tag"]);

	if($banner["type"] == "external"){
		$output = $banner["tag"];
	}//if
	elseif($banner["type"] == "rich"){
		$output = "<script src=\"".URL."/js/AC_RunActiveContent.js\" type=\"text/javascript\"></script><script src=\"".URL."/js/AC_ActiveX.js\" type=\"text/javascript\"></script>
		<script language=\"JavaScript\" type=\"text/javascript\" src=\"".URL."/index.php?handler=ad&action=show&ban_id=".$banner["ban_id"]."&track=".$track."\"></script>";
	}//elseif
	elseif($banner["type"] == "static"){
		list($width,$height) = getimagesize(DOC_ROOT."/ads/".$banner["primary_file"]);
		$output = "<a href=\"".URL."/index.php?handler=ad&action=go&ban_id=".$banner["ban_id"]."&track=".$track."\" target=\"_blank\"><img src=\"".URL."/ads/".$banner["primary_file"]."\" width=\"".$width."\" height=\"".$height."\" border=\"0\"></a>";
	}//elseif

	return $output;

}//extract_banner_output

function extract_encoding($type,$theme_name=0){

	static $ret = array();

	if($ret[$theme_name][$type])
		return $ret[$theme_name][$type];

	if(!$theme_name)
		$theme_name = $GLOBALS["THEME"];

	include(DOC_ROOT."/includes/config/encodings.inc.php");

	include(DOC_ROOT."/includes/themes.inc.php");

	$theme = $themes[$theme_name];

	$ret[$theme_name] = $encoding[$theme["encoding"]];

	if($type == "html")
		return $encoding[$theme["encoding"]]["html"];
	elseif($type == "mysql")
		return $encoding[$theme["encoding"]]["mysql"];

}//extract_encoding

function extract_microtime(){

	$mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];

    return $mtime;

}//extract_microtime

function extract_new_messages($mem_id,$time_period){

	$sql_query = "SELECT COUNT(*) FROM mailbox WHERE `date` >= ".$time_period." AND `date` < ".time()."
				  AND mem_id=".$mem_id." AND viewed='0'
				  AND mailbox != 'sent'";

	$new_messages = $GLOBALS["DB"]->single($sql_query);

	return $new_messages;

}//extract_new_messages

function extract_package_price($price,$currency,$interval,$period){

	if(empty($price))
		return "Free Account";

	$package_price = extract_option("currencies",$currency);
	$package_price.= $price." ";
	if($interval){
		$package_price.= $GLOBALS["language"]["every"]." ".$interval." ";
		if($interval > 1)
			$package_price.= $GLOBALS["language"][$period."s"];
		else
			$package_price.= $GLOBALS["language"][$period];
	}//if
	else{
		$package_price.= $GLOBALS["language"]["One time"];
	}//else

	return $package_price;

}//extract_package_price

function extract_plan_price($plan,$price,$currency){

	$plan = ucfirst(strtolower($plan));

	$plan_price = extract_option("currencies",$currency);
	$plan_price.= $price." ";
	$plan_price.= $GLOBALS["language"][$plan];

	return $plan_price;

}//extract_plan_price

function extract_free_package(){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");

	return $getpaid["free"]["allow"];

}//extract_free_package

function extract_getpaid_enabled(){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	return $getpaid["enabled"];

}//extract_getpaid_enabled

function extract_plan_period($plan){

	$period = "";

	switch($plan){
		case 'daily':
			$period = "1 day";
			break;
		case 'weekly':
			$period = "1 week";
			break;
		case 'monthly':
			$period = "1 month";
			break;
		case 'quarterly':
			$period = "3 month";
			break;
		case 'yearly':
			$period = "1 year";
			break;
	}//switch

	return $period;

}//extract_plan_period

function extract_plans($global_prices,$category_prices){

	$periods = array ("daily","weekly","monthly","quarterly","yearly");

	$plans = array();

	while(list($key,$val) = each($periods)){
		if(!empty($category_prices[$val]["price"]))
			$plans[$val] = extract_plan_price($val,$category_prices[$val]["price"],$category_prices[$val][currency]);
		elseif(!empty($global_prices[$val]["price"]))
			$plans[$val] = extract_plan_price($val,$global_prices[$val]["price"],$global_prices[$val][currency]);
	}//while

	return $plans;

}//extract_plans

function extract_psystem($theme,$psystem){

	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");

	return $getpaid["systems"][$psystem]["name"];

}//extract_psystem

function extract_available_banners(){

	global $page_details;

	$banners = array();

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/ads.inc.php");

	while(list($area,) = each($ads["areas"])){

		$info    = $GLOBALS["Member"]->info();
		$country = $info["country"];
		$page    = $page_details["items_file"];
		$module  = $page_details["page"];
		$formats = explode(",",$ads["areas"][$area][formats]);

		$campaigns = extract_available_campaigns();

		$sql_query = "SELECT ban_id FROM banners,campaigns WHERE banners.cmp_id=campaigns.cmp_id
					  AND campaigns.`status`='1' AND areas LIKE '%,".$area.",%'
					  AND campaigns.theme='".$GLOBALS["THEME"]."'
					  AND (pages='all' OR pages LIKE '%,".$page.",%')
					  AND banners.cmp_id IN (".implode(",",$campaigns).")";

		if($country)
			$sql_query.= " AND (countries='all' OR countries LIKE ',%".$country."%,')";
		else
			$sql_query.= " AND countries='all'";

		switch($module){
			case 'videos':
				$id_name = "vid_id";
				$id = $GLOBALS["Get"]->type_val("vid_id","integer");
				$table   = "videos";
				$setting = "video_categories";
				break;
			case 'groups':
				$id_name = "grp_id";
				$g = $GLOBALS["Get"]->val("g");
				$id = $GLOBALS["Get"]->type_val("grp_id","integer");
				
				if($g) {
					$q = "SELECT grp_id FROM groups WHERE folder=':g:'";
					$GLOBALS["DB"]->values = array( "g" => $g );
					$id = $GLOBALS["DB"]->single( $q );
				}
				$table   = "groups";
				$setting = "group_categories";
				break;
		}//switch

		if($id && $table && $setting){
			$category = $GLOBALS["Get"]->type_val("c","integer");
			if(!$category){
				if($id){
					$sql_query2 = "SELECT category FROM ".$table."
								   WHERE ".$id_name."=".$id;
					$result = $GLOBALS["DB"]->row($sql_query2);
					$category = $result["category"];
				}//if
			}//if

			if($category)
				$sql_query.= " AND (".$setting."='all' OR ".$setting." LIKE '%,".$category.",%')";

		}//if

		$sql_query.= " ORDER BY last_shown ASC";

		$banner = $GLOBALS["DB"]->single($sql_query);

		if($banner){
			$banners[$area] = 1;
		}//if

	}//if

	return $banners;

}//extract_available_banners

function extract_session_data($session,$mem_id){

	if(!$session || !$mem_id)
		return array();

	$sql_query = "SELECT data FROM sessiondata WHERE id=:id: AND mem_id=:mem_id:";
	$GLOBALS["DB"]->values = array("id" => $session, "mem_id" => $mem_id);
	$data = $GLOBALS["DB"]->single($sql_query);
	$values = unserialize(urldecode($data));

	if(!is_array($values))
		return array();

	foreach($values as $key=>$val){
		if(extract_null_value($val))
			unset($values[$key]);
	}//foreach

	return $values;

}//extract_session_data

function extract_mainurl(){

	$details      = parse_url(URL);
	$host_active  = $_SERVER["HTTP_HOST"];
	$host_default = $details["host"];

	if($host_active != $host_default)
		$mainurl = preg_replace("/".preg_quote($host_default,"/")."/",$host_active,URL);
	else
		$mainurl = URL;

	return $mainurl;

}//extract_mainurl

function extract_mainurl_relative() {
	if($GLOBALS["settings"]["mod_rewrite"] && $GLOBALS["page_details"]["items_file"] == "groups")
		$mainurl = "..";
	else
		$mainurl = ".";
		
	return $mainurl;
}

function extract_tags( $text ) {
	$tags = explode("|", trim( $text, "|" ) );
	$retval = "";
	foreach($tags as $tag) {
		$retval.= "<a href='".URL."/index.php?handler=tags&action=tagsearch&tag=".urlencode( $tag )."'>".$tag."</a> ";
	}
	return trim($retval);
}

function extract_mailbox_messages( $box ) {
	
	$info = $GLOBALS["Member"]->info();
	
	$messages = 0;
	
	$sql_query = "SELECT COUNT(*) FROM mailbox WHERE mailbox='".$box."' AND mem_id=".$info["mem_id"]." AND viewed='0'";
	$messages = $GLOBALS["DB"]->single( $sql_query );
		
	return $messages;
	
}

function extract_groups_base_url() {
	
	if($GLOBALS["settings"]["mod_rewrite"]) {
		return URL."/groups/";
	} else {
		return URL."/?g=";
	}
	
}

function extract_available_campaigns() {
	
	static $cache;
	
	if(is_array($cache))
		return $cache;
	
	$sql_query = "SELECT * FROM campaigns WHERE theme='".$GLOBALS["THEME"]."' AND (`end` = 0 OR `end` > ".time().") AND `status` = '1'";
	$result = $GLOBALS["DB"]->result($sql_query);

	$campaigns[] = "0";

	foreach($result as $res){
		$sql_query = "SELECT SUM(impressions) AS impressions, SUM(clicks) AS clicks
					  FROM banners WHERE cmp_id=".$res["cmp_id"];
		$performance = $GLOBALS["DB"]->row($sql_query);

		$cost = extract_campaign_cost($res["type"],$res["price"],$performance["impressions"],$performance["clicks"],$res["start"]);

		if($cost == "N/A" || $res["credit"] > $cost)
			$campaigns[] = $res["cmp_id"];

	}//foreach
	
	$cache = $campaigns;

	return $campaigns;
}

function extract_duration_from_file( $file ) {
	
	include_once(DOC_ROOT."/functions/converter/".CONVERTER.".php");
	return converter_data( $file, "duration" );
	
}

function extract_campaign_cost($type,$price,$impressions,$clicks,$start){

	if($type == "ppc"){
		$cost = $price*$clicks;
	}//if
	elseif($type == "impressions"){
		$cost = $price*($impressions/1000);
	}//elseif
	elseif($type == "subscription"){
		$months = date("n")-date("n",$start)+((date("Y")-date("Y",$start)) * 12);
		if(date("j") < date("j",$start))
			$months++;
		$cost = $price*$months;
	}//elseif
	else{
		$cost = "N/A";
	}//else

	return $cost;

}//extract_campaign_cost

?>